Scriptname SSX_Deferred_Items_Loader_Quest extends Quest

SSX_Runner_Quest Property ssxRunnerQuest Auto
Actor Property PlayerRef Auto

Function doInit()
	UnregisterForAllModEvents()
	RegisterForModEvent("ssxRescanItems", "DoRescan")
	ssxRunnerQuest.areItemsInProgress=0
	ssxRunnerQuest.log("Deferred Items Loader started", SSX_Runner_Quest.notifDeferredDetails())
EndFunction



Event DoRescan(string fromWho)
	ssxRunnerQuest.startT("MCM Items scanning " + fromWho)
	ssxRunnerQuest.log("Scanning of items for MCM started", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.areItemsInProgress=0
	
	; Init the ssxRunnerQuest lists
	while ssxRunnerQuest.currentArmorsNum
		ssxRunnerQuest.currentArmorsNum-=1
		ssxRunnerQuest.currentArmorsIDs[ssxRunnerQuest.currentArmorsNum]=""
		ssxRunnerQuest.currentArmorsNames[ssxRunnerQuest.currentArmorsNum]=""
	endWhile
	ssxRunnerQuest.areItemsInProgress=1
	
	; Load all items in the inventory
	Form[] items = PlayerRef.GetContainerForms()
	ObjectReference underCrossHair = Game.GetCurrentCrosshairRef()
	float step = 0.0
	float progress = 1.0
	int i = items.length
	if i
		step = 50.0/i
		while i
			i -= 1
			String id = PO3_SKSEFunctions.GetFormEditorID(items[i])
			if items[i].getType()==26 && ssxRunnerQuest.currentArmorsIDs.find(id)==-1 && ssxRunnerQuest.currentArmorsNum<ssxRunnerQuest.currentArmorsIDs.length ; Valid Armor
				ssxRunnerQuest.currentArmorsNames[ssxRunnerQuest.currentArmorsNum] = items[i].getName()
				if ssxRunnerQuest.currentArmorsNames[ssxRunnerQuest.currentArmorsNum] != ""
					ssxRunnerQuest.currentArmorsIDs[ssxRunnerQuest.currentArmorsNum] = id
					ssxRunnerQuest.currentArmorsNum += 1
					if ssxRunnerQuest.currentArmorsNum>=ssxRunnerQuest.currentArmorsIDs.length
						i=0
					endIf
				endIf
			endIf
			progress += step
			ssxRunnerQuest.areItemsInProgress = progress as Int
		endWhile
	endIf
	
	ssxRunnerQuest.areItemsInProgress=50
	if underCrossHair
		items = underCrossHair.GetContainerForms()
		i = items.length
		if i
			step = 50.0/i
			while i
				i -= 1
				String id = PO3_SKSEFunctions.GetFormEditorID(items[i])
				if items[i].getType()==26 && ssxRunnerQuest.currentArmorsIDs.find(id)==-1 && ssxRunnerQuest.currentArmorsNum<ssxRunnerQuest.currentArmorsIDs.length ; Valid Armor
					ssxRunnerQuest.currentArmorsNames[ssxRunnerQuest.currentArmorsNum] = items[i].getName()
					if ssxRunnerQuest.currentArmorsNames[ssxRunnerQuest.currentArmorsNum]!=""
						ssxRunnerQuest.currentArmorsIDs[ssxRunnerQuest.currentArmorsNum] = id
						ssxRunnerQuest.currentArmorsNum += 1
						if ssxRunnerQuest.currentArmorsNum>=ssxRunnerQuest.currentArmorsIDs.length
							i=0
						endIf
					endIf
				endIf
				progress += step
				ssxRunnerQuest.areItemsInProgress = progress as Int
			endWhile
		endIf
	endIf
	ssxRunnerQuest.areItemsInProgress = 100
	
	ssxRunnerQuest.log("Scanning of items for MCM completed", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.endT("MCM Items scanning " + fromWho)
EndEvent











