Scriptname SSX_Deferred_Mods_Loader_Quest extends Quest ; V1.4

SSX_Runner_Quest Property ssxRunnerQuest Auto

Function doInit()
	UnregisterForAllModEvents()
	RegisterForModEvent("ssxScanMods", "getMods")
	ssxRunnerQuest.areModsInProgress=0
	ssxRunnerQuest.log("Deferred Mods Loader started", SSX_Runner_Quest.notifDeferredDetails())
EndFunction

Event getMods(String unused)
	Utility.waitMenuMode(3.0)
	ssxRunnerQuest.startT("MCM Mods scanning and sorting")
	ssxRunnerQuest.log("Scanning of mods for MCM started", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.areModsInProgress=0

	int count = Game.GetModCount()
	int i = count
	ssxRunnerQuest.mods = SSX_Runner_Quest.CreateStringArray(i)
	while i
		i-=1
		ssxRunnerQuest.mods[i]=Game.GetModName(i)
	endWhile
	ssxRunnerQuest.areModsInProgress = 10
	Utility.waitMenuMode(0.5)

	PapyrusUtil.SortStringArray(ssxRunnerQuest.mods, false)
	ssxRunnerQuest.areModsInProgress = 40

	i = count
	int j = i
	if i>64
		j=64
	endIf
	i-=j
	ssxRunnerQuest.modsSet1 = SSX_Runner_Quest.CreateStringArray(j)
	j = i
	if i>64
		j=64
	endIf
	i-=j
	ssxRunnerQuest.modsSet2 = SSX_Runner_Quest.CreateStringArray(j)
	j = i
	if i>64
		j=64
	endIf
	i-=j
	ssxRunnerQuest.modsSet3 = SSX_Runner_Quest.CreateStringArray(j)
	j = i
	if i>64
		j=64
	endIf
	i-=j
	ssxRunnerQuest.modsSet4 = SSX_Runner_Quest.CreateStringArray(j)
	Utility.waitMenuMode(0.2)
	ssxRunnerQuest.areModsInProgress = 50

	j = count
	i=0
	while i<64 && i<j
		ssxRunnerQuest.modsSet1[i] = ssxRunnerQuest.mods[i]
		i+=1
	endWhile
	Utility.waitMenuMode(1.0)
	ssxRunnerQuest.areModsInProgress = 60
	while i<128 && i<j
		ssxRunnerQuest.modsSet2[i - 64] = ssxRunnerQuest.mods[i]
		i+=1
	endWhile
	Utility.waitMenuMode(1.0)
	ssxRunnerQuest.areModsInProgress = 70
	while i<192 && i<j
		ssxRunnerQuest.modsSet3[i - 128] = ssxRunnerQuest.mods[i]
		i+=1
	endWhile
	Utility.waitMenuMode(1.0)
	ssxRunnerQuest.areModsInProgress = 80
	while i<254 && i<j
		ssxRunnerQuest.modsSet4[i - 192] = ssxRunnerQuest.mods[i]
		i+=1
	endWhile

	ssxRunnerQuest.areModsInProgress = 100
	
	ssxRunnerQuest.log("Scanning of mods for MCM completed", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.endT("MCM Mods scanning and sorting")
EndEvent











