Scriptname SSX_Rule_Alias extends ReferenceAlias Hidden ; V1.4h
{Contains the values and the functions to define and execute the Scent of Sex rules}

; ((- Core Rule properties 


; Start mode = 0 random, 1 player, 2 event (nudity, bleedout, combat, sleep), player
; Filters = nudity, see nudity, see sex, ar, he, st, ma, sneak, weap, combat, unc, rule, clothing, time, location

int Property id Auto
int Property status Auto ; 0=Not good, 1=Potential (not all participant are OK but there is people), 2=ready to be played, 3=beeing played
String Property name auto
bool Property automaticName auto
String Property author auto
String Property description auto
int Property dst Auto
int Property src Auto
int Property coll Auto
String Property dstIDs Auto ; semicolon separated IDs that can be: ActorIDs, RelationshipIDs, FactionIDs
String Property srcIDs Auto ; semicolon separated IDs that can be: ActorIDs, RelationshipIDs, FactionIDs
String Property collIDs Auto ; semicolon separated IDs that can be: ActorIDs, RelationshipIDs, FactionIDs
String Property dstNegFactIDs Auto ; semicolon separated IDs that for the factions to be avoided
String Property srcNegFactIDs Auto ; semicolon separated IDs that for the factions to be avoided
String Property collNegFactIDs Auto ; semicolon separated IDs that for the factions to be avoided
int Property partsProp auto
; partsProp 
; 00 0000 0000 0000
; XF EEDD DCCB BBAA
; A = num Collaborators - 2 bits is the number of collaborators
; B = Do Not Involve Me - one bit for each position about the involvement (0=involved, 1=not involved)
; C = Victim - two bits are used to understand who is the victim
; D = Number Spectators - three bits to enable spectator crowds number
; E = Spectators masturbate - 2 bits to define who will masturbate
; F = Optional Collaborators - single bit to define if the collaborators are optional

String Property dstRaces auto ; Filter on the races for the Target. If empty there are no filters
String Property srcRaces auto ; Filter on the races for the Source. If empty there are no filters
String Property collRaces auto ; Filter on the races for the Collaborator. If empty there are no filters
int Property raceMode auto ; bit 0 is mode for Dst, bit 1 is mode for Src, bit 2 is mode for Coll
int Property passiveIs Auto
; Passive role
; 0=dst
; 1=src
; 2=coll
; 3=random
; 4=female (dst fallback)
; 5=femdom mode (female will be active)
; 6=gay (dst fallback, only if using SL Sexuality)
; 7=gay or female (dst fallback with priority, only if using SL Sexuality)
; 8=female or gay (dst fallback with priority, only if using SL Sexuality)

float Property lastRunTime Auto ; used to store the last run time for the rule
float Property timeBeforeReDo Auto ; If not zero, then this amount of time has to pass before the rule can be played again

int Property andOrForTags auto ; Bitfield for a few options
;0 - 1  = And/Or not aggressive (1 = Or)
;1 - 2  = And/Or aggressive (1 = Or)
;2 - 4  = Aggressive required (1 = yes)
;3 - 8  = Aggressive required (1 = yes)
;4 - 16 = Use lead in (1 = yes)

String Property tags auto ; tags are all the tags the consensual animation has to have. The animations are searched by using the tags in AND or OR mode depending on the next Property.
String Property avoid auto ; Tags that the consensual animation should NOT have
String Property tagsA auto ; tags are all the tags the aggressive animation has to have. The animations are searched by using the tags in AND or OR mode depending on the next Property.
String Property avoidA auto ; Tags that the aggressive animation should NOT have
String Property specificAnimIDs Auto ; SexLab anim IDs for specific anims to be played
String Property specificAnimAIDs Auto ; SexLab anim IDs for specific aggressive anims to be played


; 2 bits for gender tags consensual (0=add them, 1=add lazy, 2=add but if fail remove, 3=don't add)
; 2 bits for gender tags aggressive (0=add them, 1=add lazy, 2=add but if fail remove, 3=don't add)
; 2 bits for player gender tags consensual (0=normal, 1=male, 2=female, 3=bisexual)
; 2 bits for player gender tags aggressive (0=normal, 1=male, 2=female, 3=bisexual)
int Property addGenderTags auto 
int Property probability auto
int Property aggressive auto
int Property beds auto 
; Pre version 1.4d, needs to be converted: 0 never, 1 ask for player, 2 ask for NPC, 3 always ask, 4 use for player, 5 use for NPC, 6 always use, 7 mandatory
; Conversion: 0->0, 1->2, 2->6, 3->8, 4->1, 5->3, 6->4, 7->9
; 0=Never
; 1=Player uses, NPCs don't
; 2=Ask for Player, NPCs don't
; 3=Player don't, NPCs use
; 4=Player and NPCs use
; 5=Ask for Player, NPCs use
; 6=Player don't, Ask for NPCs
; 7=Player uses, Ask for NPCs
; 8=Ask for Player and NPCs
; 9=mandatory

; Asking sex is a bit array. The first bit tells if is possible to have asking for sex. Then a bit for Use SpeachCraft. Then a reserved bit for future use
; Then 3 bits for Rape perc, then 3 bits for Mast perc (The values are 0=0%, 1=25%, 2=50%, 3=75%, 4=Always), then 3 bits for aggressive on denials
int Property askingSex Auto
int Property stopAllCombats Auto ; 0=Nope; 1=only if Player/Followers are involved; 2=always
int Property dialogues  Auto ; 4 bits request (0-based), 4 bits pos answer (0 based), 4 bits neg answer (0 based), 4 bits final sentence (1 based, 0=not used), 3 bits pos prob, 3 bits neg prob ; pos: 0=request, 1=pos answ, 2=neg answ, 3=final sent

Location[] Property realLocations Auto
Cell[] Property realCells Auto
keyword[] Property realLocKeywords Auto
int Property scaleActors Auto ; 0=Use SexLab, 1=Force Scaling, 2=Disable Scaling

int Property inUse Auto ; 0 Not defined; 1 Disabled; 2 Active
int Property enableOrgies Auto ; 0 No, te rule will play once, until selected again; 1 Yes, the rule will start as many scenes as possible, until the actors are consumed
int Property startsOn Auto ; 0 = random, 1 = player asks, 2 = rule sequence
int Property filter1 Auto ; be naked, see naked, see sex, ar, he, st, ma, sl, sn, we, co, bl, un, cl, lo
int Property filter2 Auto ; be naked, see naked, see sex, ar, he, st, ma, sl, sn, we, co, bl, un, cl, lo
int Property filter3 Auto ; be naked, see naked, see sex, ar, he, st, ma, sl, sn, we, co, bl, un, cl, lo
int Property timeFilter Auto ; 5 bits for the start time, 5 bits for the end time
String Property dstMods Auto ; semicolon separated list of valid mods for the position
String Property srcMods Auto ; semicolon separated list of valid mods for the position
String Property collMods Auto ; semicolon separated list of valid mods for the position
int Property prevRule Auto ; ID of the rule that will trigger this one
int Property arousalLevel auto ; The value to be used to understnad if the actor arousal level is high enough, -1 to ignore
int Property healthLevel auto ; Value used to understand if the affected position has the helth of the appropriate level
int Property staminaLevel auto ; Value used to understand if the affected position has the stamina of the appropriate level
int Property magickaLevel auto ; Value used to understand if the affected position has the Magicka of the appropriate level
String Property hasToWearDst Auto ; Safe IDs of the items that needs be wore to start the rule
String Property notToWearDst Auto ; Safe IDs of the items that have not to be wear to start the rule
String Property hasToWearSrc Auto ; Safe IDs of the items that needs be wore to start the rule
String Property notToWearSrc Auto ; Safe IDs of the items that have not to be wear to start the rule
String Property hasToWearColl Auto ; Safe IDs of the items that needs be wore to start the rule
String Property notToWearColl Auto ; Safe IDs of the items that have not to be wear to start the rule
int Property interiorExterior Auto ; 0=ignore, 1=only interior cells, 2=only exterior cells, third bit is to understand if cells are inclusive or exclusive
String Property locations Auto ; <id & 0xFFFF>|<Modname>; <id & 0xFFFF>|<Modname>; ... if empty the all locations are valid
String Property cells Auto ; <id & 0xFFFF>|<Modname>; <id & 0xFFFF>|<Modname>; ... if empty the all locations are valid
String Property locationTypes Auto ; IDs (real one, direct) of the keyword for the locations that are possible

Int Property stripping Auto ; sequence of 2 bits for Dst, Src, and Coll: 01=not undress at startl 10=Keep naked at end
String Property wearAtStartDst Auto ; Safe IDs of a set of objects that have to be equipped by the Dst at starting
String Property wearAtStartSrc Auto ; Safe IDs of a set of objects that have to be equipped by the Src at starting
String Property wearAtStartColl Auto ; Safe IDs of a set of objects that have to be equipped by the Coll at starting
String Property wearAtEndDst Auto ; Safe IDs of a set of objects that have to be equipped by the Dst at end of the rule
String Property wearAtEndSrc Auto ; Safe IDs of a set of objects that have to be equipped by the Src at end of the rule
String Property wearAtEndColl Auto ; Safe IDs of a set of objects that have to be equipped by the Coll at the end of the rule


Actor[] Property validDst Auto
Actor[] Property validSrc Auto
Actor[] Property validColl Auto
int Property allValidNum Auto ; first 6 bits Dst, then Src, the Coll
Actor[] Property potentialDst Auto
Actor[] Property potentialSrc Auto
Actor[] Property potentialColl Auto
int Property allPotentialNum Auto ; first 6 bits Dst, then Src, the Coll

; mods
; 0=ssxRunnerQuest
; 1=rule checker
; 2=rule player
; 3=event catcher
int Property highLights Auto ; 3 bits color + 4 bits mod X position


Armor[] hasToWearARDstList
Armor[] hasToWearARSrcList
Armor[] hasToWearARCollList
Armor[] notToWearARDstList
Armor[] notToWearARSrcList
Armor[] notToWearARCollList
Keyword[] hasToWearKWDstList
Keyword[] hasToWearKWSrcList
Keyword[] hasToWearKWCollList
Keyword[] notToWearKWDstList
Keyword[] notToWearKWSrcList
Keyword[] notToWearKWCollList

; -))

; ((- ---------------------------------- Rule Init Functions ---------------------------------------------------------------------------------------------------------------------

Function init(String nn)
	id = Utility.RandomInt(1, 65535)
	status = 0
	name = nn
	automaticName = true
	author = Game.getPlayer().getDisplayName()
	description=""
	inUse = 0
	
	setParticipant(0, 3, 3, 3, 1)
	setParticipant(1, 3, 3, 3, 0)
	setParticipant(2, 3, 3, 3, 0)
	partsProp = 0
	dstIDs = ""
	srcIDs = ""
	collIDs = ""
	srcRaces = ""
	dstRaces = ""
	collRaces = ""
	dstNegFactIDs = ""
	srcNegFactIDs = ""
	collNegFactIDs = ""
	raceMode = 0
	passiveIs = 0
	lastRunTime = 0.0
	timeBeforeReDo = 0.0
	andOrForTags=4 ; "AND mode" in both consensual and aggressive. Automatically add aggressive tag for aggressive consequences if missing
	tags=""
	avoid=""
	specificAnimIDs = ""
	tagsA=""
	avoidA=""
	specificAnimAIDs = ""
	addGenderTags=5 ; Add them lazy by default in both consensual and aggressive, and normal player tags (straight)
	probability = 1
	aggressive = 0
	beds = 0
	askingSex = 0 ; Not asking, No speechcraft
	setPercRape(0) ; Never
	setPercMast(0) ; Never
	setPercRapeAggr(0) ; Never
	scaleActors = 0
	stopAllCombats =1
	startsOn = 0 ; Pure random
	enableOrgies = 0
	filter1 = 0
	filter2 = 0
	filter3 = 0
	prevRule = -1
	timeFilter = -1
	arousalLevel = -1
	healthLevel = -1
	staminaLevel = -1
	magickaLevel = -1
	hasToWearDst = ""
	notToWearDst = ""
	hasToWearSrc = ""
	notToWearSrc = ""
	hasToWearColl = ""
	notToWearColl = ""
	interiorExterior = 0
	locations = ""
	cells = ""
	locationTypes = ""
	stripping = 0
	wearAtStartDst = ""
	wearAtStartSrc  = ""
	wearAtStartColl = ""
	wearAtEndDst = ""
	wearAtEndSrc = ""
	wearAtEndColl = ""
	dialogues = 0x200000 ; First Dialogue, First Answer positive, First Answer negative, First final sentence (that means none), Max probability postive, NEVER as Refusal probability
	highLights = 0
	dstMods = ""
	srcMods = ""
	collMods = ""
	realLocations = new Location[32]
	realLocKeywords = new Keyword[32]
	realCells = new Cell[32]
	validDst = new Actor[32]
	validSrc = new Actor[32]
	validColl = new Actor[32]
	potentialDst = new Actor[32]
	potentialSrc = new Actor[32]
	potentialColl = new Actor[32]
	generateLocations()
	generateClothes()
	clearValidActors()
endFunction

Function copyFrom(SSX_Rule_Alias srcR)
	id = srcR.id
	if id < 1
		id = Utility.RandomInt(1, 65535)
	endIf
	status = 0
	name = srcR.name
	automaticName = srcR.automaticName
	author = srcR.author
	description = srcR.description
	inUse = srcR.inUse

	src = srcR.src
	dst = srcR.dst
	coll = srcR.coll
	dstIDs = srcR.dstIDs
	srcIDs = srcR.srcIDs
	collIDs = srcR.collIDs
	partsProp = srcR.partsProp
	srcRaces = srcR.srcRaces
	dstRaces = srcR.dstRaces
	collRaces = srcR.collRaces
	dstNegFactIDs = srcR.dstNegFactIDs
	srcNegFactIDs = srcR.srcNegFactIDs
	collNegFactIDs = srcR.collNegFactIDs
	raceMode = srcR.raceMode
	passiveIs = srcR.passiveIs
	lastRunTime = 0.0
	timeBeforeReDo = srcR.timeBeforeReDo
	andOrForTags = srcR.andOrForTags
	tags = srcR.tags
	avoid = srcR.avoid
	specificAnimIDs = srcR.specificAnimIDs
	tagsA = srcR.tagsA
	avoidA = srcR.avoidA
	specificAnimAIDs = srcR.specificAnimAIDs
	addGenderTags = srcR.addGenderTags
	probability = srcR.probability
	aggressive = srcR.aggressive
	beds = srcR.beds
	askingSex = srcR.askingSex
	scaleActors = srcR.scaleActors
	stopAllCombats = srcR.stopAllCombats
	enableOrgies = srcR.enableOrgies
	startsOn = srcR.startsOn
	prevRule = srcR.prevRule
	filter1 = srcR.filter1
	filter2 = srcR.filter2
	filter3 = srcR.filter3
	timeFilter = srcR.timeFilter
	arousalLevel = srcR.arousalLevel
	healthLevel = srcR.healthLevel
	staminaLevel = srcR.staminaLevel
	magickaLevel = srcR.magickaLevel
	hasToWearDst = srcR.hasToWearDst
	notToWearDst = srcR.notToWearDst
	hasToWearSrc = srcR.hasToWearSrc
	notToWearSrc = srcR.notToWearSrc
	hasToWearColl = srcR.hasToWearColl
	notToWearColl = srcR.notToWearColl
	interiorExterior = srcR.interiorExterior
	locations = srcR.locations
	cells = srcR.cells
	locationTypes = srcR.locationTypes
	stripping = srcR.stripping
	wearAtStartDst = srcR.wearAtStartDst
	wearAtStartSrc  = srcR.wearAtStartSrc
	wearAtStartColl = srcR.wearAtStartColl
	wearAtEndDst = srcR.wearAtEndDst
	wearAtEndSrc = srcR.wearAtEndSrc
	wearAtEndColl = srcR.wearAtEndColl
	dialogues = srcR.dialogues
	highLights = srcR.highLights
	dstMods = srcR.dstMods
	srcMods = srcR.srcMods
	collMods = srcR.collMods
	if !realLocations
		realLocations = new Location[32]
	endIf
	if !realLocKeywords
		realLocKeywords = new Keyword[32]
	endIf
	if !realCells
		realCells = new Cell[32]
	endIf
	if !validDst
		validDst = new Actor[32]
	endIf
	if !validSrc
		validSrc = new Actor[32]
	endIf
	if !validColl
		validColl = new Actor[32]
	endIf
	if !potentialDst
		potentialDst = new Actor[32]
	endIf
	if !potentialSrc
		potentialSrc = new Actor[32]
	endIf
	if !potentialColl
		potentialColl = new Actor[32]
	endIf
	generateLocations()
	generateClothes()
	clearValidActors()
endFunction

bool Function didAnyChange(SSX_Rule_Alias srcR)
	if src!=srcR.src || dst!=srcR.dst || coll!=srcR.coll || dstIDs!=srcR.dstIDs || srcIDs!=srcR.srcIDs || collIDs!=srcR.collIDs || partsProp!=srcR.partsProp || srcRaces!=srcR.srcRaces || dstRaces!=srcR.dstRaces || collRaces!=srcR.collRaces || raceMode!=srcR.raceMode
		return true
	endIf
	if dstNegFactIDs!=srcR.dstNegFactIDs || srcNegFactIDs!=srcR.srcNegFactIDs || collNegFactIDs!=srcR.collNegFactIDs || passiveIs!=srcR.passiveIs || timeBeforeReDo!=srcR.timeBeforeReDo || tags!=srcR.tags
		return true
	endIf
	if andOrForTags!=srcR.andOrForTags || addGenderTags!=srcR.addGenderTags || avoid!=srcR.avoid || tagsA!=srcR.tagsA || avoidA!=srcR.avoidA || specificAnimIDs!=srcR.specificAnimIDs
		return true
	endIf
	if specificAnimAIDs!=srcR.specificAnimAIDs || probability!=srcR.probability || aggressive!=srcR.aggressive || beds!=srcR.beds || askingSex!=srcR.askingSex
		return true
	endIf
	if scaleActors!=srcR.scaleActors || stopAllCombats!=srcR.stopAllCombats || startsOn!=srcR.startsOn || prevRule!=srcR.prevRule || filter1!=srcR.filter1 || filter2!=srcR.filter2
		return true
	endIf
	if filter3!=srcR.filter3 || timeFilter!=srcR.timeFilter || arousalLevel!=srcR.arousalLevel || healthLevel!=srcR.healthLevel || staminaLevel!=srcR.staminaLevel || magickaLevel!=srcR.magickaLevel || hasToWearDst!=srcR.hasToWearDst
		return true
	endIf
	if notToWearDst!=srcR.notToWearDst || hasToWearSrc!=srcR.hasToWearSrc || notToWearSrc!=srcR.notToWearSrc || hasToWearColl!=srcR.hasToWearColl || notToWearColl!=srcR.notToWearColl || interiorExterior!=srcR.interiorExterior || locations!=srcR.locations || cells!=srcR.cells
		return true
	endIf
	if locationTypes!=srcR.locationTypes || stripping!=srcR.stripping || wearAtStartDst!=srcR.wearAtStartDst || wearAtStartSrc !=srcR.wearAtStartSrc || wearAtStartColl!=srcR.wearAtStartColl || wearAtEndDst!=srcR.wearAtEndDst
		return true
	endIf
	if wearAtEndSrc!=srcR.wearAtEndSrc || wearAtEndColl!=srcR.wearAtEndColl || dialogues!=srcR.dialogues || highLights!=srcR.highLights || dstMods!=srcR.dstMods || srcMods!=srcR.srcMods || collMods!=srcR.collMods
		return true
	endIf
	return false
endFunction

; -))

; ((- ----------------------------------- Rule Start Functions ---------------------------------------------------------------------------------------------------------------------

bool Function startsByPlayerAsking()
	return startsOn==1
endFunction

int Function canPlayerBeInvolvedBOorHE()
	if inUse != 2
		return 0
	endIf
	if isPlayer(0) || isGenericWPl(0)
		if isStartingOn(12, 0, -1, -1)
			if isStartingOn(5, 0, -1, -1)
				return 3
			else
				return 1
			endIf
		else
			if isStartingOn(5, 0, -1, -1)
				return 2
			else
				return 0
			endIf
		endIf
	endIf
	if isPlayer(1) || isGenericWPl(1)
		if isStartingOn(12, -1, 0, -1)
			if isStartingOn(5, -1, 0, -1)
				return 13
			else
				return 11
			endIf
		else
			if isStartingOn(5, -1, 0, -1)
				return 12
			else
				return 0
			endIf
		endIf
	endIf
	if isPlayer(2) || isGenericWPl(2)
		if isStartingOn(12, -1, -1, 0)
			if isStartingOn(5, -1, -1, 0)
				return 23
			else
				return 21
			endIf
		else
			if isStartingOn(5, -1, -1, 0)
				return 22
			else
				return 0
			endIf
		endIf
	endIf
	return 0
endFunction

bool Function needEquippedItems(int pos)
	if pos==-1
		return hasToWearDst!="" || notToWearDst!="" || (!isNobody(1) && (hasToWearSrc!="" || notToWearSrc!="")) || (!isNobody(2) && (hasToWearColl!="" || notToWearColl!=""))
	elseIf pos==0
		return hasToWearDst!="" || notToWearDst!=""
	elseIf pos==1
		return hasToWearSrc!="" || notToWearSrc!=""
	endIf
	return hasToWearColl!="" || notToWearColl!=""
endFunction


Function wearAtStart(int pos, Actor a, bool[] stripSlots, sslThreadModel t)
	if !a
		return
	endIf
	String toWear = ""
	if pos==targetPosition()
		toWear = wearAtStartDst
	elseIf pos==sourcePosition()
		toWear = wearAtStartSrc
	elseIf pos==collaboratorPosition()
		toWear = wearAtStartColl
	endIf 
	if toWear==""
		return
	endIf
	int i = 33
	while i
		i-=1
		stripSlots[i]=true
	endWhile
	bool setStripping=false
	String[] parts = StringUtil.split(toWear, ";")
	i = parts.length
	while i
		i -= 1
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f
			if a.getItemCount(f)==0
				a.addItem(f, 1)
			endIf
			a.equipItemEx(f, 0, true, true)
			int slotMask = (f as Armor).GetSlotMask()
			int p = 0
			while p<33
				if Math.LogicalAnd(slotMask, 1)==1
					stripSlots[p]=false
					setStripping=true
				endIf
				slotMask = math.RightShift(slotMask, 1)
				p+=1
			endWhile
		endIf
	endWhile
	if setStripping
		t.SetStrip(a, stripSlots)
	endIf
endFunction

Function wearAtEnd(int pos, Actor a)
	if !a
		return
	endIf
	String wore = ""
	String toWear = ""
	if pos==targetPosition()
		wore = wearAtStartDst
		toWear = wearAtEndDst
	elseIf pos==sourcePosition()
		wore = wearAtStartSrc
		toWear = wearAtEndSrc
	elseIf pos==collaboratorPosition()
		wore = wearAtStartColl
		toWear = wearAtEndColl
	endIf 
	if wore!=""
		; Something to remove
		String[] parts = StringUtil.split(toWear, ";")
		int i = parts.length
		while i
			i -= 1
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if f
				a.unEquipItemEx(f, 0, false)
			endIf
		endWhile
	endIf
	if toWear==""
		return
	endIf
	String[] parts = StringUtil.split(toWear, ";")
	int i = parts.length
	while i
		i -= 1
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f
			if a.getItemCount(f)==0
				a.addItem(f, 1)
			endIf
			a.equipItemEx(f, 0, false, true)
		endIf
	endWhile
endFunction

String[] Function getWearAtStart(int pos)
	String toWear = ""
	if pos==targetPosition()
		toWear = wearAtStartDst
	elseIf pos==sourcePosition()
		toWear = wearAtStartSrc
	elseIf pos==collaboratorPosition()
		toWear = wearAtStartColl
	endIf 
	if toWear==""
		return new String[1]
	endIf
	String[] parts = StringUtil.split(toWear, ";")
	int i = parts.length
	int num=0
	while i
		i -= 1
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f && f.getName()!=""
			num+=1
		endIf
	endWhile
	String[] res = SSX_Runner_Quest.CreateStringArray(num)
	i = parts.length
	num=0
	while i
		i -= 1
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f && f.getName()!=""
			res[num] = f.getName()
			num+=1
		endIf
	endWhile
	return res
endFunction

String[] Function getWearAtEnd(int pos)
	String toWear = ""
	if pos==targetPosition()
		toWear = wearAtEndDst
	elseIf pos==sourcePosition()
		toWear = wearAtEndSrc
	elseIf pos==collaboratorPosition()
		toWear = wearAtEndColl
	endIf 
	if toWear==""
		return new String[1]
	endIf
	String[] parts = StringUtil.split(toWear, ";")
	int i = parts.length
	int num=0
	while i
		i -= 1
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f && f.getName()!=""
			num+=1
		endIf
	endWhile
	String[] res = SSX_Runner_Quest.CreateStringArray(num)
	i = parts.length
	num=0
	while i
		i -= 1
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f && f.getName()!=""
			res[num] = f.getName()
			num+=1
		endIf
	endWhile
	return res
endFunction

Function setWearable(int pos, bool atStart, String armorID)
	if armorID=="" ; Remove all
		if pos==0
			if atStart
				wearAtStartDst=""
			else
				wearAtEndDst=""
			endIf
		elseIf pos==1
			if atStart
				wearAtStartSrc=""
			else
				wearAtEndSrc=""
			endIf
		else
			if atStart
				wearAtStartColl=""
			else
				wearAtEndColl=""
			endIf
		endIf
		return
	endIf
	String val
	if pos==0
		if atStart
			val=wearAtStartDst
		else
			val=wearAtEndDst
		endIf
	elseIf pos==1
		if atStart
			val=wearAtStartSrc
		else
			val=wearAtEndSrc
		endIf
	else
		if atStart
			val=wearAtStartColl
		else
			val=wearAtEndColl
		endIf
	endIf
	if StringUtil.find(val, armorID)!=-1
		return
	endIf
	if val==""
		val=armorID
	else
		val+=";" + armorID
	endIf
	if pos==0
		if atStart
			wearAtStartDst=val
		else
			wearAtEndDst=val
		endIf
	elseIf pos==1
		if atStart
			wearAtStartSrc=val
		else
			wearAtEndSrc=val
		endIf
	else
		if atStart
			wearAtStartColl=val
		else
			wearAtEndColl=val
		endIf
	endIf	
endFunction

Function removeWearable(int pos, bool atStart, int item)
	String[] parts
	if atStart
		if pos==0
			parts=StringUtil.split(wearAtStartDst, ";")
		elseIf pos==1
			parts=StringUtil.split(wearAtStartSrc, ";")
		else
			parts=StringUtil.split(wearAtStartColl, ";")
		endIf
		int i = 0
		String val=""
		while i<parts.length
			if i!=item
				val+=parts[i]+";"
			endIf
			i+=1
		endWhile
		if StringUtil.getLength(val)>1
			val = StringUtil.subString(val, 0, StringUtil.getLength(val) - 1)
		endIf
		if pos==0
			wearAtStartDst=val
		elseIf pos==1
			wearAtStartSrc=val
		else
			wearAtStartColl=val
		endIf
	else
		if pos==0
			parts=StringUtil.split(wearAtEndDst, ";")
		elseIf pos==1
			parts=StringUtil.split(wearAtEndSrc, ";")
		else
			parts=StringUtil.split(wearAtEndColl, ";")
		endIf
		int i = 0
		String val=""
		while i<parts.length
			if i!=item
				val+=parts[i]+";"
			endIf
			i+=1
		endWhile
		if StringUtil.getLength(val)>1
			val = StringUtil.subString(val, 0, StringUtil.getLength(val) - 1)
		endIf
		if pos==0
			wearAtEndDst=val
		elseIf pos==1
			wearAtEndSrc=val
		else
			wearAtEndColl=val
		endIf
	endIf
endFunction

String Function getHasToWear(int pos, bool hasTo)
	if pos==0
		if hasTo
			return hasToWearDst
		else
			return notToWearDst
		endIf
	elseIf pos==1
		if hasTo
			return hasToWearSrc
		else
			return notToWearSrc
		endIf
	else
		if hasTo
			return hasToWearColl
		else
			return notToWearColl
		endIf
	endIf
	return ""
endFunction


Armor[] Function getItemsToWear(int pos)
	if pos==0
		return hasToWearARDstList
	elseIf pos==1
		return hasToWearARSrcList
	endIf
	return hasToWearARCollList
endFunction

Keyword[] Function getKWToWear(int pos)
	if pos==0
		return hasToWearKWDstList
	elseIf pos==1
		return hasToWearKWSrcList
	endIf
	return hasToWearKWCollList
endFunction

Armor[] Function getItemsNotToWear(int pos)
	if pos==0
		return notToWearARDstList
	elseIf pos==1
		return notToWearARSrcList
	endIf
	return notToWearARCollList
endFunction

Keyword[] Function getKWNotToWear(int pos)
	if pos==0
		return notToWearKWDstList
	elseIf pos==1
		return notToWearKWSrcList
	endIf
	return notToWearKWCollList
endFunction


; Returns true if clothing is important for the position
bool Function checkHasToWear(int pos)
	if pos==0
		return hasToWearDst!="" || notToWearDst!=""
	elseIf pos==1
		return hasToWearSrc!="" || notToWearSrc!=""
	endIf
	return hasToWearColl!="" || notToWearColl!=""
endFunction

bool Function setHasToWear(int pos, bool hasTo, String wid)
	if pos==0
		if hasTo
			if StringUtil.find(hasToWearDst, wid)!=-1
				return false
			endIf
			if hasToWearDst==""
				hasToWearDst=wid
			else
				hasToWearDst+=";"+wid
			endIf
			return true
		else
			if StringUtil.find(notToWearDst, wid)!=-1
				return false
			endIf
			if notToWearDst==""
				notToWearDst=wid
			else
				notToWearDst+=";"+wid
			endIf
			return true
		endIf
	elseIf pos==1
		if hasTo
			if StringUtil.find(hasToWearSrc, wid)!=-1
				return false
			endIf
			if hasToWearSrc==""
				hasToWearSrc=wid
			else
				hasToWearSrc+=";"+wid
			endIf
			return true
		else
			if StringUtil.find(notToWearSrc, wid)!=-1
				return false
			endIf
			if notToWearSrc==""
				notToWearSrc=wid
			else
				notToWearSrc+=";"+wid
			endIf
			return true
		endIf
	else
		if hasTo
			if StringUtil.find(hasToWearColl, wid)!=-1
				return false
			endIf
			if hasToWearColl==""
				hasToWearColl=wid
			else
				hasToWearColl+=";"+wid
			endIf
			return true
		else
			if StringUtil.find(notToWearColl, wid)!=-1
				return false
			endIf
			if notToWearColl==""
				notToWearColl=wid
			else
				notToWearColl+=";"+wid
			endIf
			return true
		endIf
	endIf
	return false
endFunction

Function clearHasToWear(int pos, bool hasTo)
	if pos==0
		if hasTo
			hasToWearDst=""
		else
			notToWearDst=""
		endIf
	elseIf pos==1
		if hasTo
			hasToWearSrc=""
		else
			notToWearSrc=""
		endIf
	else
		if hasTo
			hasToWearColl=""
		else
			notToWearColl=""
		endIf
	endIf
endFunction

Function clearNthHasToWear(int pos, bool hasTo, int index)
	if pos==0
		if hasTo
			hasToWearDst=_clearNthHasToWear(hasToWearDst, index)
		else
			notToWearDst=_clearNthHasToWear(notToWearDst, index)
		endIf
	elseIf pos==1
		if hasTo
			hasToWearSrc=_clearNthHasToWear(hasToWearSrc, index)
		else
			notToWearSrc=_clearNthHasToWear(notToWearSrc, index)
		endIf
	else
		if hasTo
			hasToWearColl=_clearNthHasToWear(hasToWearColl, index)
		else
			notToWearColl=_clearNthHasToWear(notToWearColl, index)
		endIf
	endIf
endFunction

String Function _clearNthHasToWear(String orig, int index)
	String res=""
	String[] parts = StringUtil.split(orig, ";")
	int i=0
	while i<parts.length
		if i!=index
			res+=parts[i]+";"
		endIf
		i+=1
	endWhile
	if res!=""
		return StringUtil.substring(res, 0, StringUtil.getLength(res) - 1)
	endIf
	return ""
endFunction

bool Function hasItemsToWear(int pos)
	if pos==0
		return hasToWearDst!=""
	elseIf pos==1
		return hasToWearSrc!=""
	endIf
	return hasToWearColl!=""
endFunction

bool Function hasItemsNotToWear(int pos)
	if pos==0
		return notToWearDst!=""
	elseIf pos==1
		return notToWearSrc!=""
	endIf
	return notToWearColl!=""
endFunction

bool Function isInHasToWear(int pos, Armor piece)
	if !piece
		return true
	endIf
	if pos==0
		if hasToWearARDstList.find(piece)!=-1
			return true
		endIf
		int i=8
		while i
			i-=1
			if hasToWearKWDstList[i] && piece.hasKeyword(hasToWearKWDstList[i])
				return true
			endIf
		endWhile
		return false
	elseIf pos==1
		if hasToWearARSrcList.find(piece)!=-1
			return true
		endIf
		int i=8
		while i
			i-=1
			if hasToWearKWSrcList[i] && piece.hasKeyword(hasToWearKWSrcList[i])
				return true
			endIf
		endWhile
		return false
	endIf
	if hasToWearARCollList.find(piece)!=-1
		return true
	endIf
	int i=8
	while i
		i-=1
		if hasToWearKWCollList[i] && piece.hasKeyword(hasToWearKWCollList[i])
			return true
		endIf
	endWhile
	return false
endFunction

bool Function isInNotToWear(int pos, Armor piece)
	if !piece
		return true
	endIf
	if pos==0
		if notToWearARDstList.find(piece)!=-1
			return true
		endIf
		int i=8
		while i
			i-=1
			if notToWearKWDstList[i] && piece.hasKeyword(notToWearKWDstList[i])
				return true
			endIf
		endWhile
		return false
	elseIf pos==1
		if notToWearARSrcList.find(piece)!=-1
			return true
		endIf
		int i=8
		while i
			i-=1
			if notToWearKWSrcList[i] && piece.hasKeyword(notToWearKWSrcList[i])
				return true
			endIf
		endWhile
		return false
	endIf
	if notToWearARCollList.find(piece)!=-1
		return true
	endIf
	int i=8
	while i
		i-=1
		if notToWearKWCollList[i] && piece.hasKeyword(notToWearKWCollList[i])
			return true
		endIf
	endWhile
	return false
endFunction



; --- Start filters -----
; 5 bits for each condition
;  1	1 0-4 be naked (event)
;  2	1 5-9 see naked
;  3	1 10-14 see sex
;  4	1 15-19 arousal
;  5	1 20-24 health (event)
;  6	1 25-29 stamina
;  7	2 0-4 magicka
;  8	2 5-9 sleep (event)
;  9	2 10-14 sneak
; 10	2 15-19 weapon
; 11	2 20-24 combat (event)
; 12	2 25-29 bleedout (event)
; 13	3 0-4 unconscious
; 14	3 5-9 wearables
; 
; Each group ov values is conisdered by 3 * 3 * 3 for each participant position
; 0 Ignored (position not to check), 1 Has to (or great than), 2 Has not (or less than)
; clothes, locations, and timers are defined directly

int Function getPositionStartMode(int startFilter, int pos)
	if startFilter==0
		return 0
	endIf
	startFilter-=1
	int val = 0
	if startFilter<7
		val = Math.LogicalAnd(Math.RightShift(filter1, startFilter * 5), 0x1F)
	elseIf startFilter<13
		val = Math.LogicalAnd(Math.RightShift(filter2, (startFilter - 7) * 5), 0x1F)
	else
		val = Math.LogicalAnd(Math.RightShift(filter3, (startFilter - 13) * 5), 0x1F)
	endIf
	; now get the specific position
	if pos==-1 ; All of them
		return val
	elseIf pos==0
		return val % 3
	elseIf pos==1
		return val / 3 % 3
	elseIf pos==2
		return val / 9 % 3
	endIf
	return 0
endFunction

; This function sets the actual stating mode in the rule, by type and mode
; 0 Ignored, 1 Has to (or great than), 2 Has not (or less than), -1 don't change it
Function setStartOn(int startFilter, int target, int source, int collaborator, int slider=-1)
	if startFilter==0
		filter1=0
		filter2=0
		filter3=0
		timeFilter=-1
		arousalLevel = -1
		healthLevel = -1
		staminaLevel = -1
		magickaLevel = -1
		hasToWearDst = ""
		notToWearDst = ""
		hasToWearSrc = ""
		notToWearSrc = ""
		hasToWearColl = ""
		notToWearColl = ""
		return
	endIf
	int val = getPositionStartMode(startFilter, -1)
	int valD = val % 3
	int valS = val / 3 % 3
	int valC = val / 9 % 3
	startFilter -= 1
	int mask = 0
	if target!=-1
		valD=target
	endIf
	if source!=-1
		valS=source
	endIf
	if collaborator!=-1
		valC=collaborator
	endIf
	
	if startFilter<7
		mask = 0xFFFFFFFF - Math.LeftShift(0x1F, startFilter * 5)
		filter1 = Math.LogicalOr(Math.LogicalAnd(filter1, mask), Math.LeftShift(valD + 3 * valS + 9 * valC, startFilter * 5))
	elseIf startFilter<13
		mask = 0xFFFFFFFF - Math.LeftShift(0x1F, (startFilter - 7) * 5)
		filter2 = Math.LogicalOr(Math.LogicalAnd(filter2, mask), Math.LeftShift(valD + 3 * valS + 9 * valC, (startFilter - 7) * 5))
	else
		mask = 0xFFFFFFFF - Math.LeftShift(0x1F, (startFilter - 13) * 5)
		filter3 = Math.LogicalOr(Math.LogicalAnd(filter3, mask), Math.LeftShift(valD + 3 * valS + 9 * valC, (startFilter - 13) * 5))
	endIf
	if slider!=-1
		if startFilter==3 ; Arousal
			arousalLevel=slider
		elseIf startFilter==4 ; Health
			healthLevel=slider
		elseIf startFilter==5 ; Stamina
			staminaLevel=slider
		elseIf startFilter==6 ; Magicka
			magickaLevel=slider
		endIf
	endIf
endFunction

Function setStartOnCompact(int startFilter, int dsc, int slider=-1)
	if startFilter==0
		filter1=0
		filter2=0
		filter3=0
		timeFilter=-1
		return
	endIf
	startFilter -= 1
	int mask = 0
	
	if startFilter<7
		mask = 0xFFFFFFFF - Math.LeftShift(0x1F, startFilter * 5)
		filter1 = Math.LogicalOr(Math.LogicalAnd(filter1, mask), Math.LeftShift(dsc, startFilter * 5))
	elseIf startFilter<13
		mask = 0xFFFFFFFF - Math.LeftShift(0x1F, (startFilter - 7) * 5)
		filter2 = Math.LogicalOr(Math.LogicalAnd(filter2, mask), Math.LeftShift(dsc, (startFilter - 7) * 5))
	else
		mask = 0xFFFFFFFF - Math.LeftShift(0x1F, (startFilter - 13) * 5)
		filter3 = Math.LogicalOr(Math.LogicalAnd(filter3, mask), Math.LeftShift(dsc, (startFilter - 13) * 5))
	endIf
	if slider!=-1
		if startFilter==3 ; Arousal
			arousalLevel=slider
		elseIf startFilter==4 ; Health
			healthLevel=slider
		elseIf startFilter==5 ; Stamina
			staminaLevel=slider
		elseIf startFilter==6 ; Magicka
			magickaLevel=slider
		endIf
	endIf
endFunction

; Checks if the positions required in the positin filter are actually valid position
int Function checkPositionFilters(int val)
	if (val % 3)!=0 && isNobody(0)
		return 1
	elseIf (val / 3 % 3)!=0 && isNobody(1)
		return 2
	elseIf (val / 9 % 3)!=0 && isNobody(2)
		return 3
	endIf
	return 0
endFunction

; startFilter
; 0=remove all, 1=be naked, 2=see naked, 3=see sex, 4=arousal, 5=health, 6=stamina, 7=magicka
; 8=sleep, 9=sneak, 10=weapon, 11=combat, 12=bleedout, 13=unconscious

Function setStartTimer(int startT, int endT)
	timeFilter = (startT % 24) + 32 * (endT % 24)
	if timeFilter==0
		timeFilter=-1
	endIf
endFunction

int Function getStartTimer(bool startT)
	if timeFilter==-1
		return -1
	endIf
	if startT
		return timeFilter % 32
	endIf
	return timeFilter / 32
endFunction

; Checks if the rule starts with the specified start condition type
; The values for the positions are: -1=Ignore, 0=should be there, 1=should be there and do, 2=should be there and dont do, 
bool Function isStartingOn(int startFilter, int dstP=-1, int srcP=-1, int collP=-1)
	if startFilter==0
		return filter1==0 && filter2==0 && filter3==0 && timeFilter==-1
	endIf
	startFilter -= 1

	int mask = 0
	int val = 0
	if startFilter<7
		mask = Math.LeftShift(0x1F, startFilter * 5)
		val = Math.RightShift(Math.LogicalAnd(filter1, mask), startFilter * 5)
	
	elseIf startFilter<13
		mask = Math.LeftShift(0x1F, (startFilter - 7) * 5)
		val = Math.RightShift(Math.LogicalAnd(filter2, mask), (startFilter - 7) * 5)

	else
		mask = Math.LeftShift(0x1F, (startFilter - 13) * 5)
		val = Math.RightShift(Math.LogicalAnd(filter3, mask), (startFilter - 13) * 5)
	
	endIf
	
	if val==0
		return false
	endIf
	if dstP==0 ; should be there, both cases are valid
		if val % 3 == 0
			return false
		endIf
	elseif dstP==1 ; should be there and do
		if val % 3 != 1
			return false
		endIf
	elseif dstP==2 ; should be there and dont do
		if val % 3 != 2
			return false
		endIf
	endIf
	if srcP==0
		if val / 3 % 3 == 0
			return false
		endIf
	elseif srcP==1
		if val / 3 % 3 != 1
			return false
		endIf
	elseif srcP==2
		if val / 3 % 3 != 2
			return false
		endIf
	endIf
	if collP==0
		if val / 9 % 3 == 0
			return false
		endIf
	elseif collP==1
		if val / 9 % 3 != 1
			return false
		endIf
	elseif collP==2
		if val / 9 % 3 != 2
			return false
		endIf
	endIf
	return true
endFunction

int Function getHealthLevelMode(int pos)
{Gets the helth level for the rule, negative if less than, postitive if greather than. Zero if not used}
	int mode = getPositionStartMode(5, pos)
	if mode==0
		return 0
	endIf
	if mode==1
		return healthLevel
	else
		return -healthLevel
	endIf
endFunction

; ---

; 0=remove all, 1=be naked, 2=see naked, 3=see sex, 4=arousal, 5=health, 6=stamina, 7=magicka
; 8=sleep, 9=sneak, 10=weapon, 11=combat, 12=bleedout, 13=unconscious

int Function getSMBeNaked() global
	return 1
endFunction
int Function getSMSeeNaked() global
	return 2
endFunction
int Function getSMSeeSex() global
	return 3
endFunction
int Function getSMArousal() global
	return 4
endFunction
int Function getSMHealth() global
	return 5
endFunction
int Function getSMStamina() global
	return 6
endFunction
int Function getSMMagicka() global
	return 7
endFunction
int Function getSMSleep() global
	return 8
endFunction
int Function getSMSneak() global
	return 9
endFunction
int Function getSMWeapon() global
	return 10
endFunction
int Function getSMCombat() global
	return 11
endFunction
int Function getSMBleedout() global
	return 12
endFunction
int Function getSMUnconscious() global
	return 13
endFunction
int Function getSMWearables() global
	return 14
endFunction

; -))

bool Function hasRelationship()
	return (dstIDs!="" && isRelationship(0)) || (srcIDs!="" && isRelationship(1)) || (collIDs!="" && isRelationship(2))
endFunction


bool Function neededPos(int pos, int tmp1, int tmp2, int tmp3) global
	; Go to all possible start conditions, and check if the specified position is defined
	int val = 0
	if pos==targetPosition()
		val=4
	elseIf pos==sourcePosition()
		val=8
	elseIf pos==collaboratorPosition()
		val=16
	endIf
	int i = 6
	while i
		i-=1
		if Math.LogicalAnd(Math.RightShift(Math.LogicalAnd(tmp1, Math.LeftShift(0x1F, i * 5)), i * 5), val)!=0
			return true
		endIf
	endWhile
	i = 6
	while i
		i-=1
		if Math.LogicalAnd(Math.RightShift(Math.LogicalAnd(tmp2, Math.LeftShift(0x1F, i * 5)), i * 5), val)!=0
			return true
		endIf
	endWhile
	i = 6
	while i>1
		i-=1
		if Math.LogicalAnd(Math.RightShift(Math.LogicalAnd(tmp3, Math.LeftShift(0x1F, i * 5)), i * 5), val)!=0
			return true
		endIf
	endWhile
	
	; Check Clothes, they are special
	val = Math.RightShift(Math.LogicalAnd(tmp3, Math.LeftShift(0x1F, 5)), 5)
	if pos==0 && (val % 3 != 0)
		return true
	elseIf pos==1 && (val / 3 % 3 != 0)
		return true
	elseIf pos==1 && (val / 9 % 3 != 0)
		return true
	endIf
	
	return false
endFunction



; ((- ----------------------------------- Actors and Creatures ---------------------------------------------------------------------------------------------------------------------

bool Function isPlayerInvolved()
	return isPlayer(0) || isPlayer(1) || isPlayer(2) || isGenericWPl(0) || isGenericWPl(1) || isGenericWPl(2)
endFunction

bool Function isPlayerInvolvedAndParticipating()
	if (isPlayer(0) || isGenericWPl(0)) && Math.LogicalAnd(partsProp, 4)!=4
		return true
	elseIf (isPlayer(1) || isGenericWPl(1)) && Math.LogicalAnd(partsProp, 8)!=8
		return true
	elseIf (isPlayer(2) || isGenericWPl(2)) && Math.LogicalAnd(partsProp, 16)!=16
		return true
	endIf
	return false
endFunction



int Function requiresPlayerProtected(bool protectOnHealth)
	if inUse!=2
		return 0
	endIf
	int res=0
	if isPlayer(0) || (isGenericWPl(0) && isHuman(0))
		if isStartingOn(12, 0, -1, -1)
			res+=1
		endIf
		if protectOnHealth && isStartingOn(5, 0, -1, -1)
			res+=2
		endIf
		return res
	endIf
	if isPlayer(1) || (isGenericWPl(1) && isHuman(1))
		if isStartingOn(12, -1, 0, -1)
			res+=1
		endIf
		if protectOnHealth && isStartingOn(5, -1, 0, -1)
			res+=2
		endIf
		return res
	endIf
	if isPlayer(2) || (isGenericWPl(2) && isHuman(2))
		if isStartingOn(12, -1, -1, 0)
			res+=1
		endIf
		if protectOnHealth && isStartingOn(5, -1, -1, 0)
			res+=2
		endIf
		return res
	endIf
	return 0
endFunction


int Function getNumPlayers()
	int res = 0
	if Math.LogicalAnd(partsProp, 4)==0
		res = 1
	endIf
	if !isNobody(1) && Math.LogicalAnd(partsProp, 8)==0
		res += 1
	endIf
	if !isNobody(2) && Math.LogicalAnd(partsProp, 16)==0
		res += Math.LogicalAnd(partsProp, 3)
	endIf
	return res
endFunction

int Function getNumNonInvolved()
	int res = 0
	if Math.LogicalAnd(partsProp, 4)==4
		res = 1
	endIf
	if !isNobody(1) && Math.LogicalAnd(partsProp, 8)==8
		res += 1
	endIf
	if !isNobody(2) && Math.LogicalAnd(partsProp, 16)==16
		res += Math.LogicalAnd(partsProp, 3)
	endIf
	return res
endFunction


int Function getNumColls() ; 0000 0000 0000 0011
	if isNobody(2)
		return 0
	endIf
	return Math.LogicalAnd(partsProp, 3)
endFunction

Function setNumColls(int num) ; 0000 0000 0000 0011
	if isNobody(2) || num>3 || num<1
		num=0
	endIf
	partsProp = Math.LogicalAnd(partsProp, 0xFFFFFC) + num
endFunction


bool Function validActor(Actor a, int pos=-1)
	if pos==0
		return validDst.find(a)!=-1 || potentialDst.find(a)!=-1
	elseIf pos==1
		return validSrc.find(a)!=-1 || potentialSrc.find(a)!=-1
	elseIf pos==2
		return validColl.find(a)!=-1 || potentialColl.find(a)!=-1
	endIf
	return validDst.find(a)!=-1 || potentialDst.find(a)!=-1 || validSrc.find(a)!=-1 || potentialSrc.find(a)!=-1 || validColl.find(a)!=-1 || potentialColl.find(a)!=-1
endFunction

int Function countDefinedPositions()
	int res = 0
	if !isNobody(2)
		res += 1
	endIf
	if !isNobody(1)
		res += 1
	endIf
	if !isNobody(0)
		res += 1
	endIf
	return res
endFunction

bool Function hasCreatures()
	return isCreature(0) || isCreature(1) || isCreature(2)
endFunction

; Checks if a position that has creatures, allows also humans
bool Function hasAlsoHumans()
	return (!isCreature(0) || (isCreature(0) && isHuman(0))) && (!isCreature(1) || (isCreature(1) && isHuman(1))) && (!isCreature(2) || (isCreature(2) && isHuman(2)))
endFunction

Function removeActor(Actor a)
	int pos = validDst.find(a)
	if pos!=-1
		int num = Math.LogicalAnd(0x3F, allValidNum)
		if num>0
			validDst[pos] = validDst[num - 1]
			allValidNum = Math.LogicalAnd(0x3FFC0, allValidNum) + (num - 1)
		else
			validDst[pos] = None
			allValidNum = Math.LogicalAnd(0x3FFC0, allValidNum)
		endIf
	endIf
	pos = validSrc.find(a)
	if pos!=-1
		int num = Math.RightShift(Math.LogicalAnd(0xFC0, allValidNum), 6)
		if num>0
			validSrc[pos] = validDst[num - 1]
			allValidNum = Math.LogicalAnd(0x3F03F, allValidNum) + Math.LeftShift(num - 1, 6)
		else
			validSrc[pos] = None
			allValidNum = Math.LogicalAnd(0x3F03F, allValidNum)
		endIf
	endIf
	pos = validColl.find(a)
	if pos!=-1
		int num = Math.RightShift(Math.LogicalAnd(0x3F000, allValidNum), 12)
		if num>0
			validColl[pos] = validDst[num - 1]
			allValidNum = Math.LogicalAnd(0xFFF, allValidNum) + Math.LeftShift(num - 1, 12)
		else
			validColl[pos] = None
			allValidNum = Math.LogicalAnd(0xFFF, allValidNum)
		endIf
	endIf
endFunction

; -))

; ((- ----------------------------------- Race Filters ---------------------------------------------------------------------------------------------------------------------

Bool Function areRaceFilterPossible(int pos)
{In case the position cannot support race filters (Player, Nobody, and Same Race will not require or allow RaceFilters, return false}
	int val = 0
	if pos == targetPosition()
		return !isPlayer(0) && !isNobody(0) && !isSameRace(0)
	elseIf pos == sourcePosition()
		return !isPlayer(1) && !isNobody(1) && !isSameRace(1)
	endIf 
	return !isPlayer(2) && !isNobody(2) && !isSameRace(2)
endFunction

bool Function hasRaceFilters()
{Returns true if the function has a race filter in any position}
	return srcRaces!="" || dstRaces!="" || collRaces!=""
endFunction

String[] Function getSrcRacesArray()
	if !srcRaces
		return SSX_Runner_Quest.CreateStringArray(0)
	endIf
	return StringUtil.split(srcRaces, ",")
endFunction

String[] Function getDstRacesArray()
	if !dstRaces
		return SSX_Runner_Quest.CreateStringArray(0)
	endIf
	return StringUtil.split(dstRaces, ",")
endFunction

String[] Function getCollRacesArray()
	if !collRaces
		return SSX_Runner_Quest.CreateStringArray(0)
	endIf
	return StringUtil.split(collRaces, ",")
endFunction

String Function getRaceFilter(int pos)
	if pos==0
		return dstRaces
	elseIf pos==1
		return srcRaces
	endIf
	return collRaces
endFunction

; Adds the specified race to the race filters of the position. In case the race is empty (=="") the race filter is cleaned
Function addRaceFilter(int pos, String raceName)
	String theRaces
	if pos==0
		theRaces = dstRaces
	elseIf pos==1
		theRaces = srcRaces
	else
		theRaces = collRaces
	endIf
	if raceName==""
		if pos==0
			dstRaces=""
		elseIf pos==1
			srcRaces=""
		else
			collRaces=""
		endIf
		return
	endIf
	if theRaces==""
		if pos==0
			dstRaces=raceName
		elseIf pos==1
			srcRaces=raceName
		else
			collRaces=raceName
		endIf
		return
	endIf
	if StringUtil.find(theRaces, raceName)!=-1
		return
	endIf
	if pos==0
		dstRaces+=";"+raceName
	elseIf pos==1
		srcRaces+=";"+raceName
	else
		collRaces+=";"+raceName
	endIf
endFunction

int Function getRaceMode(int pos)
	return Math.LogicalAnd(Math.RightShift(raceMode, pos), 1)
endFunction

Function setRaceMode(int pos, int mode)
	if pos==0
		raceMode = Math.LogicalAnd(raceMode, 6) + mode
	elseIf pos==1
		raceMode = Math.LogicalAnd(raceMode, 5) + 2*mode
	else
		raceMode = Math.LogicalAnd(raceMode, 3) + 4*mode
	endIf
endFunction

; -))

; ((- ----------------------------------- Tags ---------------------------------------------------------------------------------------------------------------------

Bool Function allTagsRequired(bool aggressive)
	if aggressive
		return Math.LogicalAnd(andOrForTags, 2)==2
	endIf
	return Math.LogicalAnd(andOrForTags, 1)==1
endFunction

; 11111
;0 - 1  = And/Or not aggressive
;1 - 2  = And/Or aggressive
;2 - 4  = Aggressive required
;3 - 8  = Aggressive required
;4 - 16 = Use lead in


Function setAllTagsRequired(bool aggressive, bool andOr) ; andOr==true -> Or
	if aggressive
		andOrForTags = Math.LogicalAnd(andOrForTags, 29) ; 11101
		if andOr
			andOrForTags = Math.LogicalOr(andOrForTags, 2)
		endIf
		return
	endIf
	andOrForTags = Math.LogicalAnd(andOrForTags, 30) ; 11110
	if andOr
		andOrForTags = Math.LogicalOr(andOrForTags, 1)
	endIf
endFunction

int Function aggressiveTagReqired()
	return Math.RightShift(Math.LogicalAnd(andOrForTags, 12), 2)
endFunction

Function setAggressiveTagReqired(int val)
	andOrForTags = Math.LogicalAnd(andOrForTags, 19) ; 10011
	if val
		andOrForTags = Math.LogicalOr(andOrForTags, Math.LeftShift(val, 2))
	endIf
endFunction

Function setLeadIn(bool setIt)
	andOrForTags = Math.LogicalAnd(andOrForTags, 15) ; 01111
	if setIt
		andOrForTags = Math.LogicalOr(andOrForTags, 16)
	endIf
endFunction

bool function hasLeadIn()
	return Math.LogicalAnd(andOrForTags, 16) == 16
endFunction

Bool Function canBeAggressive()
	return aggressive!=0 || (getPercRape()>0 && getPercRapeAggr()>0)
endFunction

Bool Function canOnlyBeAggressive()
	return aggressive==4 || (getPercRape()==4 && getPercRapeAggr()==4 && !isPlayer(0)) 
endFunction

Bool Function hasToBeAggressive()
	return aggressive==4 || (getPercRape()==4 && getPercRapeAggr()==4)
endFunction

; Returns 0 for string, 1 for lazy, 2 for strict first the lazy, 3 for don't add
int Function genderTagMode(bool aggressive)
	if aggressive
		return Math.RightShift(Math.LogicalAnd(addGenderTags, 12), 2)
	else
		return Math.LogicalAnd(addGenderTags, 3)
	endIf
endFunction

int Function playerGenderTagMode(bool aggressive)
	{0=normal, 1=male, 2=female, 3=bisexual}
	if aggressive
		return Math.RightShift(Math.LogicalAnd(addGenderTags, 192), 6)
	else
		return Math.RightShift(Math.LogicalAnd(addGenderTags, 48), 4)
	endIf
endFunction

Function setGenderTags(int genderTags, int playerGenderTags, bool aggressive)
	if genderTags!=-1
		if aggressive
			addGenderTags = Math.LogicalOr(Math.LogicalAnd(addGenderTags, 0xF3), Math.LeftShift(genderTags, 2))
		else
			addGenderTags = Math.LogicalOr(Math.LogicalAnd(addGenderTags, 0xFC), genderTags)
		endIf
	endIf
	if playerGenderTags!=-1
		if aggressive
			addGenderTags = Math.LogicalOr(Math.LogicalAnd(addGenderTags, 0x3F), Math.LeftShift(playerGenderTags, 6))
		else
			addGenderTags = Math.LogicalOr(Math.LogicalAnd(addGenderTags, 0xCF), Math.LeftShift(playerGenderTags, 4))
		endIf
	endIf
endFunction


; -))

; ((- ----------------------------------- Beds ---------------------------------------------------------------------------------------------------------------------

bool Function isBedRequired()
{Tells is we need to search for a bed or not}
	; 0=Never, 1=Puse Nnot, 2=Pask Nnot, 3=Pnot Nuse, 4=Puse Nuse, 5=Pask Nuse, 6=Pnot Nask, 7=Puse Nask, 8=Pask Nask, 9=mandatory
	if beds==0 ; Never
		return false
	endIf

	if isPlayerInvolved() ; Do we have the player?
		if beds==1 || beds==2 || beds==4 || beds==5 || beds==7 || beds==8 || beds==9
			return true
		endIf
	else
		if beds>2
			return true
		endIf
	endIf
	return false
endFunction

bool Function needToAskForBeds(bool doWeHaveABed)
{ Returns true is the popup message for the confirmation of bed usage should be shown}
	if !doWeHaveABed
		return false ; If we don't have a bed, then don't ask
	endIf
	; 0=Never, 1=Puse Nnot, 2=Pask Nnot, 3=Pnot Nuse, 4=Puse Nuse, 5=Pask Nuse, 6=Pnot Nask, 7=Puse Nask, 8=Pask Nask, 9=mandatory
	if isPlayerInvolved() ; Do we have the player?
		if beds==2 || beds==5 || beds==8
			return true
		endIf
	else
		if beds==6 || beds==7 || beds==8
			return true
		endIf
	endIf
	return false
endFunction

bool Function isBedMandatory()
	return beds==9
endFunction

; -))

; ((- ----------------------------------- Position event filtering Functions ------------------------------------------------------------------------------------------------

Bool Function isPosNotInvolved(int pos) ; 00 0000 0001 1100
	if pos==0
		return Math.LogicalAnd(partsProp, 4)==4
	elseIf pos==1
		return Math.LogicalAnd(partsProp, 8)==8
	endIf
	return Math.LogicalAnd(partsProp, 16)==16
endFunction

Bool Function doNotInvolveDst() ; 00 0000 0000 0100
	return Math.LogicalAnd(partsProp, 4)==4
endFunction

Bool Function doNotInvolveSrc() ; 00 0000 0000 1100
	return Math.LogicalAnd(partsProp, 8)==8
endFunction

Bool Function doNotInvolveColl() ; 00 0000 0001 0000
	return Math.LogicalAnd(partsProp, 16)==16
endFunction

int Function getVictim() ; 00 0000 0110 0000
	return Math.LogicalAnd(partsProp, 96)/32 - 1
endFunction

Function setVictim(int pos) ; 00 0000 0110 0000
	partsProp = Math.LogicalAnd(partsProp, 0xFFFF9F) + (pos+1)*32
endFunction

Function setDoNotInvolveMe(int pos, bool toBeFilteredOut) ; 00 0000 0001 1100
	if pos==0
		if toBeFilteredOut
			partsProp = Math.LogicalOr(partsProp, 4)
		else
			partsProp = Math.LogicalAnd(partsProp, 0xFFFFFF - 4)
		endIf
	elseIf pos==1
		if toBeFilteredOut
			partsProp = Math.LogicalOr(partsProp, 8)
		else
			partsProp = Math.LogicalAnd(partsProp, 0xFFFFFF - 8)
		endIf
	elseIf pos==2
		if toBeFilteredOut
			partsProp = Math.LogicalOr(partsProp, 16)
		else
			partsProp = Math.LogicalAnd(partsProp, 0xFFFFFF - 16)
		endIf
	endIf
endFunction

int Function getSpectators() ; 00 0111 1000 0000
	return Math.RightShift(Math.LogicalAnd(partsProp, 0x780), 7)
endFunction

Function setSpectators(int num) ; 00 0111 1000 0000
	partsProp = Math.LogicalOr(Math.LogicalAnd(partsProp, 0xFFF87F), Math.LeftShift(num, 7))
endFunction

int Function getSpectatorsMasturbate() ; 01 1000 0000 0000
	return Math.RightShift(Math.LogicalAnd(partsProp, 0x1800), 11)
endFunction

Function setSpectatorsMasturbate(int num) ; 01 1000 0000 0000
	partsProp = Math.LogicalOr(Math.LogicalAnd(partsProp, 0xFFE7FF), Math.LeftShift(num, 11))
endFunction

bool Function getOptionalCollaborators() ; 10 0000 0000 0000
	return Math.LogicalAnd(partsProp, 0x2000)!=0
endFunction

Function toggleOptionalCollaborators() ; 10 0000 0000 0000
	if Math.LogicalAnd(partsProp, 0x2000)!=0
		partsProp = Math.LogicalAnd(partsProp, 0xFFDFFF)
	else
		partsProp = Math.LogicalOr(partsProp, 0x2000)
	endIf
endFunction

; -))

; ((- ----------------------------------- Valid Actors  ---------------------------------------------------------------------------------------------------------------------

int Function getValidActors(int pos, Actor[] res)
	Actor[] aPos
	int num = 0
	if pos==0 ; Dst
		aPos = validDst
		num = Math.LogicalAnd(0x3F, allValidNum)
	elseIf pos==1 ; Src
		aPos = validSrc
		num = Math.RightShift(Math.LogicalAnd(0xFC0, allValidNum), 6)
	else ; Coll
		aPos = validColl
		num = Math.RightShift(Math.LogicalAnd(0x3F000, allValidNum), 12)
	endIf
	int i = num
	while i
		i-=1
		res[i] = aPos[i]
	endWhile
	i = num
	while i<res.length
		res[i] = None
		i+=1
	endWhile
	return num
endFunction

int Function getValidActorsLen(int pos)
	if pos==0 ; Dst
		return Math.LogicalAnd(0x3F, allValidNum)
	elseIf pos==1 ; Src
		return Math.RightShift(Math.LogicalAnd(0xFC0, allValidNum), 6)
	else ; Coll
		return Math.RightShift(Math.LogicalAnd(0x3F000, allValidNum), 12)
	endIf
endFunction

Function setValidActors(int pos, Actor[] acts, int actN, Actor[] pots, int potN, Faction canBeAsked)
	Actor[] aPos
	Actor[] aPot
	if pos==0 ; Dst
		aPos = validDst
		aPot = potentialDst
		allValidNum = Math.LogicalAnd(0x3FFC0, allValidNum) + actN
		allPotentialNum = Math.LogicalAnd(0x3FFC0, allPotentialNum) + potN
	elseIf pos==1 ; Src
		aPos = validSrc
		aPot = potentialSrc
		allValidNum = Math.LogicalAnd(0x3F03F, allValidNum) + Math.LeftShift(actN, 6)
		allPotentialNum = Math.LogicalAnd(0x3F03F, allPotentialNum) + Math.LeftShift(potN, 6)
	else ; Coll
		aPos = validColl
		aPot = potentialColl
		allValidNum = Math.LogicalAnd(0xFFF, allValidNum) + Math.LeftShift(actN, 12)
		allPotentialNum = Math.LogicalAnd(0xFFF, allPotentialNum) + Math.LeftShift(potN, 12)
	endIf
	
	int i = aPos.length
	while i
		i -= 1
		if aPos[i] && canBeAsked
			aPos[i].removeFromFaction(canBeAsked)
		endIf
		if i < actN
			aPos[i] = acts[i]
			if aPos[i] && canBeAsked
				aPos[i].addToFaction(canBeAsked)
			endIf
		else
			aPos[i] = none
		endIf
	endWhile

	i = aPot.length
	while i
		i -= 1
		if aPot[i] && canBeAsked
			aPot[i].removeFromFaction(canBeAsked)
		endIf
		if i < potN
			aPot[i] = pots[i]
			if aPot[i] && canBeAsked
				aPos[i].removeFromFaction(canBeAsked)
			endIf
		else
			aPot[i] = none
		endIf
	endWhile
endFunction

Function clearValidActors()
	int i = validDst.length
	while i
		i-=1
		validDst[i] = None
		validSrc[i] = None
		validColl[i] = None
	endWhile
	allValidNum = 0
endFunction

; eventType: 1=Bleed, 2=Naked, 3=Weapon, 4=Combat, 5=Sleep, 6=Health, 7=Clothes
bool Function requiresCatchers(int eventType, int pos)
	if isNobody(pos)
		return false
	endIf
	if eventType==1 && getPositionStartMode(12, pos)==1 ; Bleedout
		return true
	elseIf eventType==2 && getPositionStartMode(1, pos)!=0 ; Nude
		return true
	elseIf eventType==3 && getPositionStartMode(10, pos)!=0 ; Weapon
		return true
	elseIf eventType==4 && getPositionStartMode(11, pos)!=0 ; Combat
		return true
	elseIf eventType==5 && getPositionStartMode(8, pos)!=0 ; Sleeping
		return true
	elseIf eventType==6 && getPositionStartMode(5, pos)!=0 ; Health
		return true
	elseIf eventType==7 && checkHasToWear(pos) ; Clothes
		return true
	endIf
	return False ; No event catcher required
endFunction



; -))

; ((- ----------------------------------- Dialogues  ---------------------------------------------------------------------------------------------------------------------

; %RAg | %Ma | %Ra | __ SC As

int Function getAskBeforeSex()
	return Math.LogicalAnd(askingSex, 1)
endFunction

Function setAskBeforeSex(bool val)
	askingSex=Math.LogicalAnd(askingSex, 0xFFFFFF - 1)
	if val
		askingSex+=1
	endIf
endFunction

int Function getUseSpeechCraft()
	return Math.LogicalAnd(askingSex, 2)/2
endFunction

Function setUseSpeechCraft(bool val)
	askingSex=Math.LogicalAnd(askingSex, 0xFFFFFF - 2)
	if val
		askingSex+=2
	endIf
endFunction

int Function getPercRape()
	return Math.RightShift(Math.LogicalAnd(askingSex, 0x38), 3)
endFunction

Function setPercRape(int val)
	askingSex = math.LogicalOr(Math.LogicalAnd(askingSex, 0xFFFFFF - 0x38), Math.LeftShift(val, 3))
endFunction

int Function getPercMast()
	return Math.RightShift(Math.LogicalAnd(askingSex, 0x1C0), 6)
endFunction

Function setPercMast(int val)
	askingSex = math.LogicalOr(Math.LogicalAnd(askingSex, 0xFFFFFF - 0x1C0), Math.LeftShift(val, 6))
endFunction

int Function getPercRapeAggr()
	return Math.RightShift(Math.LogicalAnd(askingSex, 0xE00), 9)
endFunction

Function setPercRapeAggr(int val)
	askingSex = math.LogicalOr(Math.LogicalAnd(askingSex, 0xFFFFFF - 0xE00), Math.LeftShift(val, 9))
endFunction


; 4 bits request (0-based), 4 bits pos answer (0 based), 4 bits neg answer (0 based), 4 bits final sentence (1 based, 0=not used), 3 bits pos prob, 3 bits neg prob
; pos: 0=request, 1=pos answ, 2=neg answ, 3=final sent

Function setDialogue(int index, int pos)
	if pos==0 ; Request
		dialogues = Math.LogicalOr(Math.LogicalAnd(dialogues, 0x3FFFF0), index)
	elseIf pos==1 ; Positive Answer
		dialogues = Math.LogicalOr(Math.LogicalAnd(dialogues, 0x3FFF0F), Math.LeftShift(index, 4))
	elseIf pos==2 ; Negative Answer
		dialogues = Math.LogicalOr(Math.LogicalAnd(dialogues, 0x3FF0FF), Math.LeftShift(index, 8))
	elseIf pos==3 ; Final Sentence
		dialogues = Math.LogicalOr(Math.LogicalAnd(dialogues, 0x3F0FFF), Math.LeftShift(index, 12))
	endIf
endFunction

int Function getDialogue(int pos)
	if pos==0 ; Request
		return Math.LogicalAnd(dialogues, 0xF)
	elseIf pos==1 ; Positive Answer
		return Math.RightShift(Math.LogicalAnd(dialogues, 0xF0), 4)
	elseIf pos==2 ; Negative Answer
		return Math.RightShift(Math.LogicalAnd(dialogues, 0xF00), 8)
	elseIf pos==3 ; Final Sentence
		return Math.RightShift(Math.LogicalAnd(dialogues, 0xF000), 12)
	endIf
	return 0
endFunction

Function setAnswerProbability(int i, bool isPositive)
	if isPositive
		dialogues = Math.LogicalOr(Math.LogicalAnd(dialogues, 0x38FFFF), Math.LeftShift(i, 16))
	else
		dialogues = Math.LogicalOr(Math.LogicalAnd(dialogues, 0x7FFFF), Math.LeftShift(i, 19))
	endIf
endFunction

; Check if the answer will be positive or negative
bool Function positiveOrNegative()
	int pProb = Math.RightShift(Math.LogicalAnd(dialogues, 0x70000), 16)
	int nProb = Math.RightShift(Math.LogicalAnd(dialogues, 0x380000), 19)
	if pProb==0 || nProb==4; For sure positive
		return true
	endIf
	; ((- Rules for positive/negative
	; 0 x	->	positive
	; 4 x	->	negative
	; x 0	->	negative
	; x 4	->	positive
	; 1 1	->	50% positive, 50% negative
	; 1 2	->	25% positive, 75% negative
	; 1 3	->	10% positive, 90% negative
	; 2 1	->	75% positive, 25% negative
	; 2 2	->	50% positive, 50% negative
	; 2 3	->	33% positive, 66% negative
	; 3 1	->	90% positive, 10% negative
	; 3 2	->	66% positive, 33% negative
	; 3 3	->	50% positive, 50% negative
	; -))
	if pProb==4 || nProb==0 ; For sure negative
		return false
	elseIf pProb==3 && nProb==3 && Utility.RandomInt(0, 1)==0 ; 3 3	->	50% positive, 50% negative
		return true
	elseIf pProb==3 && nProb==2 && Utility.RandomInt(0, 3)==0 ; 3 2	->	25% positive, 75% negative
		return true
	elseIf pProb==3 && nProb==1 && Utility.RandomInt(0, 9)==0 ; 3 1	->	10% positive, 90% negative
		return true
	elseIf pProb==2 && nProb==3 && Utility.RandomInt(0, 3)!=0 ; 2 3	->	75% positive, 25% negative
		return true
	elseIf pProb==2 && nProb==2 && Utility.RandomInt(0, 1)==0 ; 2 2	->	50% positive, 50% negative
		return true
	elseIf pProb==2 && nProb==1 && Utility.RandomInt(0, 3)==0 ; 2 1	->	33% positive, 66% negative
		return true
	elseIf pProb==1 && nProb==3 && Utility.RandomInt(0, 9)!=0 ; 1 3	->	90% positive, 10% negative
		return true
	elseIf pProb==1 && nProb==2 && Utility.RandomInt(0, 2)!=0 ; 1 2	->	66% positive, 33% negative
		return true
	elseIf pProb==1 && nProb==1 && Utility.RandomInt(0, 1)==0 ; 1 1	->	50% positive, 50% negative
		return true
	endIf
	return false
endFunction

; A consequence can be: 0=No one, no sex, 1=consensual sex, 2=rape, 3=masturbation, 4=brawl
; In case the asked person is the player, just calculate the negative answer result
; In case the asking person is the player, then we may want to use Speechcraft
; sceneMode: 0=player asks, 1=player asked, 2=NPCs
int Function calculateConsequence(int sceneMode, int playerSpeechCraft = -1)
	if sceneMode==0 ; Player aks
		; Positive or negative? Based on speechcraft or random
		if playerSpeechCraft!=-1 ; Speechcraft
			if Utility.RandomInt(0,100)<=playerSpeechCraft
				return 1 ; Consensual
			else ; Negative, calculated later
			endIf
		else ; Random
			if positiveOrNegative()
				return 1 ; Positive
			else ; Negative, calculated later
			endIf
		endIf
	
	elseIf sceneMode==1 ; Player asked, calculate only the negative result (0, 2, 3)
		; Negative, calculated later
	else ; NPCs
			if positiveOrNegative()
				return 1 ; Positive
			else ; Negative, calculated later
			endIf
	endIf
	
	; ((- Calculate the negative result (rapeProb, mastProb)
	; 4 4	->	0
	; 0 x	->	2
	; x 0	->	3
	; 1 1	->	50% 0, 25% 2, 25% 3
	; 1 2	->	25% 0, 25% 2, 50% 3
	; 1 3	->	25% 0, 10% 2, 65% 3
	; 2 1	->	25% 0, 50% 2, 25% 3
	; 2 2	->	33% 0, 33% 2, 33% 3
	; 2 3	->	10% 0, 30% 2, 60% 3
	; 3 1	->	25% 0, 65% 2, 10% 3
	; 3 2	->	10% 0, 60% 2, 30% 3
	; 3 3	->	10% 0, 45% 2, 45% 3 -))
	int pProb = getPercRape()
	int nProb = getPercMast()

	if pProb==0 && nProb==0; For sure no consequences
		return 0
	elseIf pProb==4 && nProb==4; For sure some sex, rape or masturbation. 50%/50%
		if Utility.randomInt(0,1)==0
			return 2
		else
			return 3
		endIf
	elseIf pProb==4
		return 2
	elseIf nProb==4
		return 3
	elseIf pProb==3 && nProb==3	; 3 3	->	50% 0, 25% 2, 25% 3
		int val=Utility.RandomInt(0, 3)
		if val<2
			return 0
		elseIf val<3
			return 2
		else
			return 3
		endIf
	elseIf pProb==3 && nProb==2	; 3 2	->	25% 0, 25% 2, 50% 3
		int val=Utility.RandomInt(0, 3)
		if val<1
			return 0
		elseIf val<2
			return 2
		else
			return 3
		endIf
	elseIf pProb==3 && nProb==1	; 3 1	->	20% 0, 10% 2, 70% 3
		int val=Utility.RandomInt(0, 9)
		if val<2
			return 0
		elseIf val<3
			return 2
		else
			return 3
		endIf
	elseIf pProb==2 && nProb==3	; 2 3	->	25% 0, 50% 2, 25% 3
		int val=Utility.RandomInt(0, 3)
		if val<1
			return 0
		elseIf val<3
			return 2
		else
			return 3
		endIf
	elseIf pProb==2 && nProb==2	; 2 2	->	33% 0, 33% 2, 33% 3
		int val=Utility.RandomInt(0, 2)
		if val<1
			return 0
		elseIf val<2
			return 2
		else
			return 3
		endIf
	elseIf pProb==2 && nProb==1	; 2 1	->	10% 0, 30% 2, 60% 3
		int val=Utility.RandomInt(0, 9)
		if val<1
			return 0
		elseIf val<4
			return 2
		else
			return 3
		endIf
	elseIf pProb==1 && nProb==3	; 1 3	->	20% 0, 70% 2, 10% 3
		int val=Utility.RandomInt(0, 9)
		if val<3
			return 0
		elseIf val<9
			return 2
		else
			return 3
		endIf
	elseIf pProb==1 && nProb==2	; 1 2	->	10% 0, 60% 2, 30% 3
		int val=Utility.RandomInt(0, 9)
		if val<1
			return 0
		elseIf val<7
			return 2
		else
			return 3
		endIf
	elseIf pProb==1 && nProb==1	; 1 1	->	10% 0, 45% 2, 45% 3
		int val=Utility.RandomInt(0, 8)
		if val<1
			return 0
		elseIf val<5
			return 2
		else
			return 3
		endIf
	endIf
	
	; If we reach this point we have a serious calculation problem
	debug.trace("SSX: Significant error in calculating the final answer. Please report it as bug with the extraction of the rule.")
	return 0	
endFunction

int Function calculateAnswer(int type)
	if type==0 ; Negative with stop
		return Math.RightShift(Math.LogicalAnd(dialogues, 0xF00), 8)
	elseIf type==1 ; Positive consensual
		return Math.RightShift(Math.LogicalAnd(dialogues, 0xF0), 4)
	elseIf type==2 ; Negative with rape
		return Math.RightShift(Math.LogicalAnd(dialogues, 0xF00), 8)
	else ; negative with masturbation
		return Math.RightShift(Math.LogicalAnd(dialogues, 0xF00), 8)
	endIf
endFunction

int Function getAnswerProbability(bool isPositive)
	if isPositive
		return Math.RightShift(Math.LogicalAnd(dialogues, 0x70000), 16)
	else
		return Math.RightShift(Math.LogicalAnd(dialogues, 0x380000), 19)
	endIf
endFunction


; -))

; ((- ----------------------------------- Other functions ---------------------------------------------------------------------------------------------------------------------

int[] Function fillActorsSexArray(int[] actorSex, int playerSex, int orientationMode, bool aggressive)
	{The result of this function is used to calculate the gender tags based on the rule settings}
	; Just 5 values are needed: 0=ignore, 1=maleH, 2=femaleH, 3=Human, 4=Creature

	int sex;
	bool hum;
	int i = actorSex.length
	while i
		i-=1
		actorSex[i]=0
	endWhile
	int nextPos=0

	; Dst
	if Math.LogicalAnd(partsProp, 4)==0 && !isNobody(0) ; The position is used
		if isPlayer(0)
			int plSexTagMode = playerGenderTagMode(aggressive) ; 0=normal, 1=male, 2=female, 3=bisexual
			if (plSexTagMode==0 && playerSex==0) || plSexTagMode==1 ; Only HM
				actorSex[nextPos]=1
			elseIf (plSexTagMode==0 && playerSex==1) || plSexTagMode==2 ; Only HF
				actorSex[nextPos]=2
			else
				actorSex[nextPos]=3 ; Human
			endIf
		elseIf isGeneric(0) || isGenericWPl(0) || isRelationship(0) || isFaction(0)
			sex = getSex(0)
			if isHuman(0)
				actorSex[nextPos]=sex
			else
				actorSex[nextPos]=4
			endIf
		elseIf isSpecific(0)
			; Check the sex/humanity of the specific actors and use it
			if dstIDs==""
				actorSex[nextPos]=3 ; Human by default, but it will fail
			else
				bool m = false
				bool f = false
				bool c = false
				String[] parts = StringUtil.split(dstIDs, ";")
				i = parts.length
				while i
					i -= 1
					Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Actor
					if a
						ActorBase ab = a.getActorbase()
						Race r = ab.getRace()
						if sslCreatureAnimationSlots.GetRaceKey(r)!=""
							c = true
						elseIf a.getActorbase().getSex()==0
							m = true
						else
							f = true
						endIf
					endIf
				endWhile
				if c
					actorSex[nextPos]=4
				else
					if m && !f
						actorSex[nextPos]=1
					elseIf !m && f
						actorSex[nextPos]=2
					else
						actorSex[nextPos]=3
					endIf
				endIf
			endIf
		elseIf isSameRace(0)
			actorSex[nextPos]=4
		endIf
		nextPos+=1
	endIf

	; Src
	if Math.LogicalAnd(partsProp, 8)==0 && !isNobody(1) ; The position is used
		if isPlayer(1)
			int plSexTagMode = playerGenderTagMode(aggressive) ; 0=normal, 1=male, 2=female, 3=bisexual
			if (plSexTagMode==0 && playerSex==0) || plSexTagMode==1
				actorSex[nextPos]=1
			elseIf (plSexTagMode==0 && playerSex==1) || plSexTagMode==2
				actorSex[nextPos]=2
			else
				actorSex[nextPos]=3
			endIf
		elseIf isGeneric(1) || isGenericWPl(1) || isRelationship(1) || isFaction(1)
			sex = getSex(1)
			if isHuman(1)
				actorSex[nextPos]=sex
			else
				actorSex[nextPos]=4
			endIf
		elseIf isSpecific(1)
			; Check the sex/humanity of the specific actors and use it
			if srcIDs==""
				actorSex[nextPos]=3
			else
				bool m = false
				bool f = false
				bool c = false
				String[] parts = StringUtil.split(srcIDs, ";")
				i = parts.length
				while i
					i -= 1
					Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Actor
					if a
						ActorBase ab = a.getActorbase()
						Race r = ab.getRace()
						if sslCreatureAnimationSlots.GetRaceKey(r)!=""
							c = true
						elseIf a.getActorbase().getSex()==0
							m = true
						else
							f = true
						endIf
					endIf
				endWhile
				if c
					actorSex[nextPos]=4
				else
					if m && !f
						actorSex[nextPos]=1
					elseIf !m && f
						actorSex[nextPos]=2
					else
						actorSex[nextPos]=3
					endIf
				endIf
			endIf
		elseIf isSameRace(1)
			actorSex[nextPos]=4
		endIf
		nextPos+=1
	endIf

	; Coll(s)
	if Math.LogicalAnd(partsProp, 16)==0 && !isNobody(2)
		if isPlayer(2)
			int plSexTagMode = playerGenderTagMode(aggressive) ; 0=normal, 1=male, 2=female, 3=bisexual
			if (plSexTagMode==0 && playerSex==0) || plSexTagMode==1
				actorSex[nextPos]=1
			elseIf (plSexTagMode==0 && playerSex==1) || plSexTagMode==2
				actorSex[nextPos]=2
			else
				actorSex[nextPos]=3
			endIf
		elseIf isGeneric(2) || isGenericWPl(2) || isRelationship(2) || isFaction(2)
			sex = getSex(2)
			if isHuman(2)
				actorSex[nextPos]=sex
			else
				actorSex[nextPos]=4
			endIf
		elseIf isSpecific(2)
			; Check the sex/humanity of the specific actors and use it
			if srcIDs==""
				actorSex[nextPos]=3
			else
				bool m = false
				bool f = false
				bool c = false
				String[] parts = StringUtil.split(collIDs, ";")
				i = parts.length
				while i
					i -= 1
					Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Actor
					if a
						ActorBase ab = a.getActorbase()
						Race r = ab.getRace()
						if sslCreatureAnimationSlots.GetRaceKey(r)!=""
							c = true
						elseIf a.getActorbase().getSex()==0
							m = true
						else
							f = true
						endIf
					endIf
				endWhile
				if c
					actorSex[nextPos]=4
				else
					if m && !f
						actorSex[nextPos]=1
					elseIf !m && f
						actorSex[nextPos]=2
					else
						actorSex[nextPos]=3
					endIf
				endIf
			endIf
		elseIf isSameRace(2)
			actorSex[nextPos]=4
		endIf
		nextPos+=1
	endIf

	if nextPos>0
		i = 1
		while i<Math.LogicalAnd(partsProp, 3)
			actorSex[nextPos]=actorSex[nextPos - 1]
			nextPos+=1
			i+=1
		endWhile
	endIf

	return actorSex
endFunction

; Format for the IDs of the Specific Actors = <decID, only the 5 left words>|<mod name>;<decID, only the 5 left words>|<mod name>;...

String Function getSpecificActorNames(int pos, bool onlyFirstWithDots=false)
	String val
	if pos==targetPosition()
		val=dstIDs
	elseIf pos==sourcePosition()
		val=srcIDs
	elseIf pos==collaboratorPosition()
		val=collIDs
	endIf
	if val==""
		return ""
	endIf
	String res=""
	String tmp=""
	String[] parts = StringUtil.split(val, ";")
	int i = parts.length
	while i
		i -= 1
		Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Actor
		if a
			tmp=a.getDisplayName()
			int j = StringUtil.find(tmp, " ")
			if j!=-1
				if j<6
					j = StringUtil.find(tmp, " ", j + 1)
					if j>20
						tmp = StringUtil.subString(tmp, 0, 20)+"..."
					else
						tmp = StringUtil.subString(tmp, 0, j)
					endIf
				else
						tmp = StringUtil.subString(tmp, 0, j)
				endIf
			else
			endIf
			res+=tmp
		else
			res+="Unknown"
		endIf
		if onlyFirstWithDots
			if res==""
				res="Specific"
			endIf
			if i>0
				res+="..."
			endIf
			return res
		endIf
		res+=", "
	endWhile
	if StringUtil.getLength(res)>2
		return StringUtil.subString(res, 0, StringUtil.getLength(res) - 2)
	endIf
	return res
endFunction

Actor[] Function getTheActors(int pos, bool valid)
	if pos==0
		if valid
			return validDst
		endIf
		return potentialDst
	elseIf pos==1
		if valid
			return validSrc
		endIf
		return potentialSrc
	endIf
	if valid
		return validColl
	endIf
	return potentialColl
endFunction

bool Function isActorThere(Actor a, int pos)
	if !a
		return false
	endIf
	if pos==0
		return validDst.find(a)!=-1 || potentialDst.find(a)!=-1
	elseIf pos==1
		return validSrc.find(a)!=-1 || potentialSrc.find(a)!=-1
	endIf
	return validColl.find(a)!=-1 || potentialColl.find(a)!=-1
endFunction

String Function calculateSpecificActorName(Actor a) global
	if !a
		return ""
	endIf
	return a.getDisplayName() + " (" + SSX_Runner_Quest.getObjectModName(a) + ")"
endFunction

Function internalAdd(int pos, String objid)
	if pos==targetPosition()
		if StringUtil.find(dstIDs, objid)==-1
			if dstIDs==""
				dstIDs = objid
			else
				dstIDs += ";" + objid
			endIf
		endIf
	elseIf pos==sourcePosition()
		if StringUtil.find(srcIDs, objid)==-1
			if srcIDs==""
				srcIDs = objid
			else
				srcIDs += ";" + objid
			endIf
		endIf
	elseIf pos==collaboratorPosition()
		if StringUtil.find(collIDs, objid)==-1
			if collIDs==""
				collIDs = objid
			else
				collIDs += ";" + objid
			endIf
		endIf
	endIf
endFunction

Function addMod(int pos, String mod)
	if pos==targetPosition()
		if StringUtil.find(dstMods, mod)==-1
			if dstMods==""
				dstMods = mod
			else
				dstMods += ";" + mod
			endIf
		endIf
	elseIf pos==sourcePosition()
		if StringUtil.find(srcMods, mod)==-1
			if srcMods==""
				srcMods = mod
			else
				srcMods += ";" + mod
			endIf
		endIf
	elseIf pos==collaboratorPosition()
		if StringUtil.find(collMods, mod)==-1
			if collMods==""
				collMods = mod
			else
				collMods += ";" + mod
			endIf
		endIf
	endIf
endFunction

Function clearMods(int pos)
	if pos==targetPosition()
		dstMods=""
	elseIf pos==sourcePosition()
		srcMods=""
	else
		collMods=""
	endIf
endFunction

Function removeMod(int pos, int index)
	String val
	if pos==targetPosition()
		val=dstMods
	elseIf pos==sourcePosition()
		val=srcMods
	else
		val=collMods
	endIf
	
	String[] parts = StringUtil.split(val, ";")
	int i=0
	val=""
	while i<parts.length
		if (i!=index)
			val+=parts[i]+";"
		endIf
		i+=1
	endWhile
	if val!=""
		val=StringUtil.substring(val, 0, StringUtil.getLength(val) - 1)
	endIf
	
	if pos==targetPosition()
		dstMods=val
	elseIf pos==sourcePosition()
		srcMods=val
	else
		collMods=val
	endIf
endFunction

Function addSpecificActor(int pos, Actor a)
	if !a
		return
	endIf
	String objid = PO3_SKSEFunctions.GetFormEditorID(a)
	internalAdd(pos, objid)
endFunction

Function addSpecificFaction(int pos, Faction f)
	if !f
		return
	endIf
	String objid = PO3_SKSEFunctions.GetFormEditorID(f)
	internalAdd(pos, objid)
endFunction

Function addSpecificRelationship(int pos, AssociationType at)
	if !at
		return
	endIf
	String objid = PO3_SKSEFunctions.GetFormEditorID(at)
	internalAdd(pos, objid)
endFunction

Function cleanSpecificActor(int pos)
	if pos==targetPosition()
		dstIDs=""
	elseIf pos==sourcePosition()
		srcIDs=""
	elseIf pos==collaboratorPosition()
		collIDs=""
	endIf
endFunction

bool Function checkSpecificActorsOverlapping()
	String[] p1s = StringUtil.split(dstIDs, ";")
	String[] p2s = StringUtil.split(srcIDs, ";")
	String[] p3s = StringUtil.split(collIDs, ";")
	
	int i = p1s.length
	while i
		i-=1
		if p2s.find(p1s[i])!=-1 || p3s.find(p1s[i])!=-1
			; Check if it is an actual actor, if not just ignore
			Actor tmp = PO3_SKSEFunctions.GetFormFromEditorID(p1s[i]) as Actor
			if tmp
				return true
			endIf
		endIf
	endWhile
	i = p2s.length
	while i
		i-=1
		if p3s.find(p2s[i])!=-1
			; Check if it is an actual actor, if not just ignore
			Actor tmp = PO3_SKSEFunctions.GetFormFromEditorID(p1s[i]) as Actor
			if tmp
				return true
			endIf
		endIf
	endWhile
	return false
endFunction

String Function getNegativeFactions(int pos)
	if pos==0
		return dstNegFactIDs
	elseIf pos==1
		return srcNegFactIDs
	endIf
	return collNegFactIDs
endFunction

Function addNegativeFaction(Faction f, int pos)
	String negFactIDs=getNegativeFactions(pos)
	String fid = PO3_SKSEFunctions.GetFormEditorID(f)
	if StringUtil.find(negFactIDs, fid)==-1
		if negFactIDs==""
			negFactIDs=fid
		else
			negFactIDs = negFactIDs+";"+fid
		endIf
		if pos==0
			dstNegFactIDs=negFactIDs
		elseIf pos==1
			srcNegFactIDs=negFactIDs
		elseIf pos==2
			collNegFactIDs=negFactIDs
		endIf
	endIf
endFunction

Function removeNegativeFaction(String fid, int pos)
	String negFactIDs=getNegativeFactions(pos)
	if StringUtil.find(negFactIDs, fid)!=-1
		if negFactIDs==fid
			negFactIDs=""
		else
			String[] facts = StringUtil.split(negFactIDs, ";")
			negFactIDs=""
			int i=0
			while i<facts.length
				if facts[i]!=fid
					negFactIDs+=facts[i]+";"
				endIf
				i+=1
			endWhile
			negFactIDs = StringUtil.substring(negFactIDs, 0, StringUtil.getLength(negFactIDs) - 1)
		endIf
		if pos==0
			dstNegFactIDs=negFactIDs
		elseIf pos==1
			srcNegFactIDs=negFactIDs
		elseIf pos==2
			collNegFactIDs=negFactIDs
		endIf
	endIf
endFunction

Function removeAllNegativeFaction(int pos)
	if pos==0
		dstNegFactIDs=""
	elseIf pos==1
		srcNegFactIDs=""
	elseIf pos==2
		collNegFactIDs=""
	endIf
endFunction


Function generateLocations()
	int count = 0
	String[] parts
	int i = realLocations.length
	while i
		i-=1
		realLocations[i]=None
	endWhile
	if locations!=""
		parts = StringUtil.split(locations, ";")
		i = parts.length
		while i && count<realLocations.length
			i -= 1
			Location l = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Location
			if l
				realLocations[count]=l
				count += 1
			endIf
		endWhile
	endIf
	i = realLocKeywords.length
	while i
		i-=1
		realLocKeywords[i]=None
	endWhile
	if locationTypes!=""
		parts = StringUtil.split(locationTypes, ";")
		count = 0
		i = parts.length
		while i && count<realLocKeywords.length
			i -= 1
			Keyword k = Game.GetForm(parts[i] as Int) as Keyword
			if k
				realLocKeywords[count]=k
				count += 1
			endIf
		endWhile
	endIf
	i = realCells.length
	while i
		i-=1
		realCells[i]=None
	endWhile
	if cells!=""
		parts = StringUtil.split(cells, ";")
		count = 0
		i = parts.length
		while i && count<realCells.length
			i -= 1
			Cell c = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Cell
			if c
				realCells[count]=c
				count += 1
			endIf
		endWhile
	endIf
endFunction

Function generateClothes()
	if !hasToWearARDstList || !hasToWearARSrcList || !hasToWearARCollList || !notToWearARDstList || !notToWearARSrcList || !notToWearARCollList || !hasToWearKWDstList || !hasToWearKWSrcList || !hasToWearKWCollList || !notToWearKWDstList || !notToWearKWSrcList || !notToWearKWCollList
		hasToWearARDstList = new Armor[8]
		hasToWearARSrcList = new Armor[8]
		hasToWearARCollList = new Armor[8]
		notToWearARDstList = new Armor[8]
		notToWearARSrcList = new Armor[8]
		notToWearARCollList = new Armor[8]
		hasToWearKWDstList = new Keyword[8]
		hasToWearKWSrcList = new Keyword[8]
		hasToWearKWCollList = new Keyword[8]
		notToWearKWDstList = new Keyword[8]
		notToWearKWSrcList = new Keyword[8]
		notToWearKWCollList = new Keyword[8]
	endIf
	
	String[] parts
	int i
	int numA=0
	int numK=0
	if hasToWearDst!=""
		parts = StringUtil.split(hasToWearDst, ";")
		i = parts.length
		while i
			i-=1
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if (f as Armor) && numA<8
				hasToWearARDstList[numA] = f as Armor
				numA+=1
			endIf
			if (f as Keyword) && numK<8
				hasToWearKWDstList[numK] = f as Keyword
				numK+=1
			endIf
		endWhile
		while numA<8
			hasToWearARDstList[numA]=None
			numA+=1
		endWhile
		while numK<8
			hasToWearKWDstList[numK]=None
			numK+=1
		endWhile
	else
		numA=8
		while numA
			numA-=1
			hasToWearARDstList[numA]=None
			hasToWearKWDstList[numA]=None
		endWhile
	endIf
	
	if notToWearDst!=""
		numA=0
		numK=0
		parts = StringUtil.split(notToWearDst, ";")
		i = parts.length
		while i
			i-=1
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if (f as Armor) && numA<8
				notToWearARDstList[numA] = f as Armor
				numA+=1
			endIf
			if (f as Keyword) && numK<8
				notToWearKWDstList[numK] = f as Keyword
				numK+=1
			endIf
		endWhile
		while numA<8
			notToWearARDstList[numA]=None
			numA+=1
		endWhile
	else
		numA=8
		while numA
			numA-=1
			notToWearARDstList[numA]=None
			notToWearKWDstList[numA]=None
		endWhile
	endIf
	
	if hasToWearSrc!=""
		numA=0
		numK=0
		parts = StringUtil.split(hasToWearSrc, ";")
		i = parts.length
		while i
			i-=1
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if (f as Armor) && numA<8
				hasToWearARSrcList[numA] = f as Armor
				numA+=1
			endIf
			if (f as Keyword) && numK<8
				hasToWearKWSrcList[numK] = f as Keyword
				numK+=1
			endIf
		endWhile
		while numA<8
			hasToWearARSrcList[numA]=None
			numA+=1
		endWhile
		while numK<8
			hasToWearKWSrcList[numK]=None
			numK+=1
		endWhile
	else
		numA=8
		while numA
			numA-=1
			hasToWearARSrcList[numA]=None
			hasToWearKWSrcList[numA]=None
		endWhile
	endIf
	
	if notToWearSrc!=""
		numA=0
		numK=0
		parts = StringUtil.split(notToWearSrc, ";")
		i = parts.length
		while i
			i-=1
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if (f as Armor) && numA<8
				notToWearARSrcList[numA] = f as Armor
				numA+=1
			endIf
			if (f as Keyword) && numK<8
				notToWearKWSrcList[numK] = f as Keyword
				numK+=1
			endIf
		endWhile
		while numA<8
			notToWearARSrcList[numA]=None
			numA+=1
		endWhile
		while numK<8
			notToWearKWSrcList[numK]=None
			numK+=1
		endWhile
	else
		numA=8
		while numA
			numA-=1
			notToWearARSrcList[numA]=None
			notToWearKWSrcList[numA]=None
		endWhile
	endIf
	
	if hasToWearColl!=""
		numA=0
		numK=0
		parts = StringUtil.split(hasToWearColl, ";")
		i = parts.length
		while i
			i-=1
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if (f as Armor) && numA<8
				hasToWearARCollList[numA] = f as Armor
				numA+=1
			endIf
			if (f as Keyword) && numK<8
				hasToWearKWCollList[numK] = f as Keyword
				numK+=1
			endIf
		endWhile
		while numA<8
			hasToWearARCollList[numA]=None
			numA+=1
		endWhile
		while numK<8
			hasToWearKWCollList[numK]=None
			numK+=1
		endWhile
	else
		numA=8
		while numA
			numA-=1
			hasToWearARCollList[numA]=None
			hasToWearKWCollList[numA]=None
		endWhile
	endIf
	
	if notToWearColl!=""
		numA=0
		numK=0
		parts = StringUtil.split(notToWearColl, ";")
		i = parts.length
		while i
			i-=1
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if (f as Armor) && numA<8
				notToWearARCollList[numA] = f as Armor
				numA+=1
			endIf
			if (f as Keyword) && numK<8
				notToWearKWCollList[numK] = f as Keyword
				numK+=1
			endIf
		endWhile
		while numA<8
			notToWearARCollList[numA]=None
			numA+=1
		endWhile
		while numK<8
			notToWearKWCollList[numK]=None
			numK+=1
		endWhile
	else
		numA=8
		while numA
			numA-=1
			notToWearARCollList[numA]=None
			notToWearKWCollList[numA]=None
		endWhile
	endIf
endFunction

int Function getIntExt()
	return Math.LogicalAnd(interiorExterior, 3)
endFunction

Function setIntExt(int val)
	interiorExterior = Math.LogicalOr(Math.LogicalAnd(interiorExterior, 12), val)
endFunction

bool Function getCellInclExcl() ; True in case is exclusive
	return Math.LogicalAnd(interiorExterior, 4) == 4
endFunction

Function setCellInclExcl(bool incl)
	if incl
		interiorExterior = Math.LogicalAnd(interiorExterior, 3)
	else
		interiorExterior = Math.LogicalOr(Math.LogicalAnd(interiorExterior, 3), 4)
	endIf
endFunction


; stripping --> sequence of 2 bits for Dst, Src, and Coll: 01=not undress at start, 10=Keep naked at end
int Function getStripMode(int pos)
	if pos==0
		return Math.LogicalAnd(stripping, 3)
	elseIf pos==1
		return Math.RightShift(Math.LogicalAnd(stripping, 12), 2)
	elseIf pos==2
		return Math.RightShift(Math.LogicalAnd(stripping, 48), 4)
	endIf
	return 0
endFunction

Function setStripping(int pos, int mode)
	int val = Math.LeftShift(mode, pos * 2)
	stripping = math.LogicalOr(Math.LogicalAnd(stripping, 63 - Math.LeftShift(3, pos * 2)), val)
endFunction

; -))

; ((- --------------------------------------------- Constant global functions ----------------------------------------------

; ---------- Positions (Source, Target, Collaborator) ----------
int Function targetPosition() global
	return 0
endFunction
int Function sourcePosition() global
	return 1
endFunction
int Function collaboratorPosition() global
	return 2
endFunction

int Function positionMHF() global
	return 21
endFunction
int Function positionFHF() global
	return 22
endFunction
int Function positionAHF() global
	return 23
endFunction
int Function positionMCF() global
	return 25
endFunction
int Function positionFCF() global
	return 26
endFunction
int Function positionACF() global
	return 27
endFunction
int Function positionMAF() global
	return 29
endFunction
int Function positionFAF() global
	return 30
endFunction
int Function positionAAF() global
	return 31
endFunction
int Function positionMHN() global
	return 37
endFunction
int Function positionFHN() global
	return 38
endFunction
int Function positionAHN() global
	return 39
endFunction
int Function positionMCN() global
	return 41
endFunction
int Function positionFCN() global
	return 42
endFunction
int Function positionACN() global
	return 43
endFunction
int Function positionMAN() global
	return 45
endFunction
int Function positionFAN() global
	return 46
endFunction
int Function positionAAN() global
	return 47
endFunction
int Function positionMHA() global
	return 53
endFunction
int Function positionFHA() global
	return 54
endFunction
int Function positionAHA() global
	return 55
endFunction
int Function positionMCA() global
	return 57
endFunction
int Function positionFCA() global
	return 58
endFunction
int Function positionACA() global
	return 59
endFunction
int Function positionMAA() global
	return 61
endFunction
int Function positionFAA() global
	return 62
endFunction
int Function positionAAA() global
	return 63
endFunction

int Function getType(int pos)
	if pos==0
		return Math.RightShift(dst, 6)
	elseIf pos==1
		return Math.RightShift(src, 6)
	endIf
	return Math.RightShift(coll, 6)
endFunction

int Function getPos(int pos)
	if pos==0
		return Math.LogicalAnd(dst, 63)
	elseIf pos==1
		return Math.LogicalAnd(src, 63)
	endIf
	return Math.LogicalAnd(coll, 63)
endFunction

; ---------- Bed option values ----------------------------------------
int Function bedNever() global
	return 0
endFunction
int Function bedMandatory() global
	return 9
endFunction

; -))


; ((- --------------------------------------------- Participants ----------------------------------------------

; first 6 bits are used for Sex, Fellowship, Humanity, then the remaining bits are used as integer defining the type
; 1	Male ; 2	Female ; 4 Follower ; 8 Not Follower ; 16	Human ; 32	Creature
; sex/fell/hum: 1=10=Male/Follower/Human, 2=01=Female/NotFoll/Creature, 0/3=11=Both
; Type: 0=Nobody, 1=Player, 2=Generic NPC, 3=Generic and player, 4=Specific NPC, 5=In relationship with 1st, 6=In relationship with 2nd, 7=In factions, 8=same creature

bool Function setParticipant(int pos, int sex, int fellowship, int humanity, int type)
	int t=type
	if t==-1
		t=getType(pos)
	endIf
	int s=sex
	if s==-1
		s=getSex(pos)
	endIf
	int f=fellowship
	if f==-1
		f=getFellowship(pos)
	endIf
	int h=humanity
	if h==-1
		h=getHumanity(pos)
	endIf
	if h==2
		h==0
	endIf
	int val = 0
	if t!=0
		val = Math.LogicalOr(Math.LogicalOr(Math.LeftShift(t, 6), Math.LeftShift(h, 4)), Math.LogicalOr(Math.LeftShift(f, 2), s))
	endIf
	bool res
	if pos==0
		res=(dst!=val)
		dst=val
	elseIf pos==1
		res=(src!=val)
		src=val
	else
		res=(coll!=val)
		coll=val
	endIf
	return res
endFunction

String Function getIDs(int pos)
	if pos==0
		return dstIDs
	elseIf pos==1
		return srcIDs
	endIf
	return collIDs
endFunction

String Function getMods(int pos)
	if pos==0
		return dstMods
	elseIf pos==1
		return srcMods
	endIf
	return collMods
endFunction


bool Function isNobody(int pos)
	return getType(pos)==0
endFunction

bool Function isPlayer(int pos)
	return getType(pos)==1
endFunction

bool Function canPlayer(int pos)
	int t = getType(pos) 
	return t==1 || t==3 || t==9
endFunction

bool Function isGeneric(int pos)
	return getType(pos)==2
endFunction

bool Function isGenericWPl(int pos)
	return getType(pos)==3
endFunction

bool Function isSpecific(int pos)
	return getType(pos)==4
endFunction

bool Function isRelationship(int pos)
	int val = getType(pos)
	return (val==5) || (val==6)
endFunction

bool Function isRelationship1(int pos)
	return getType(pos)==5
endFunction

bool Function isRelationship2(int pos)
	return getType(pos)==6
endFunction

bool Function isFaction(int pos)
	return getType(pos)==7
endFunction

bool Function isSameRace(int pos)
	return getType(pos)==8
endFunction

int Function getSex(int pos)
	int res = Math.LogicalAnd(getVal(pos), 3)
	if res==0
		return 3
	endIf
	return res
endFunction

bool Function isMale(int pos)
	return Math.LogicalAnd(getVal(pos), 1)==1
endFunction

bool Function isFemale(int pos)
	return Math.LogicalAnd(getVal(pos), 2)==2
endFunction

int Function getFellowship(int pos)
	int res = Math.RightShift(Math.LogicalAnd(getVal(pos), 12), 2)
	if res==0
		return 3
	endIf
	return res
endFunction

bool Function isFollower(int pos)
	return Math.LogicalAnd(getVal(pos), 4)==4
endFunction

bool Function isNotFollower(int pos)
	return Math.LogicalAnd(getVal(pos), 8)==8
endFunction

int Function getHumanity(int pos)
	int res = Math.RightShift(Math.LogicalAnd(getVal(pos), 48), 4)
	if res==0
		return 3
	endIf
	return res
endFunction

bool Function isHuman(int pos)
	return Math.LogicalAnd(getVal(pos), 16)==16
endFunction

bool Function isCreature(int pos)
	if isNobody(pos) || isPlayer(pos)
		return false
	endIf
	if isSameRace(pos)
		return true
	endIf
	if isSpecific(pos) ; OK, check if there is at least one creature
		String ids = getIDs(pos)
		String[] parts = StringUtil.split(ids, ";")
		int i = parts.length
		while i
			i-=1
			Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Actor
			if a && sslCreatureAnimationSlots.GetRaceKey(a.getLeveledActorBase().getRace())!=""
				return true
			endIf
		endWhile
		return false
	endIf
	; It is generic, check the specific settings
	if pos==0
		return Math.LogicalAnd(dst, 32)==32
	elseIf pos==1
		return Math.LogicalAnd(src, 32)==32
	endIf
	return Math.LogicalAnd(coll, 32)==32
endFunction

bool Function isMultiCreatures()
	string dRace = ""
	if isCreature(0)
		dRace=dstRaces
	endIf
	string sRace = ""
	if isCreature(1)
		sRace=srcRaces
	endIf
	string cRace = ""
	if isCreature(2)
		cRace=collRaces
	endIf
	if (dRace=="" && sRace=="") || (dRace=="" && cRace=="") || (sRace=="" && cRace=="")
		return false ; Single race or no races
	endIf
	if dRace!="" && ((sRace!="" && dRace!=sRace) || (cRace!="" && dRace!=cRace))
		return true
	elseIf sRace!="" && ((dRace!="" && dRace!=sRace) || (cRace!="" && sRace!=cRace))
		return true
	elseIf cRace!="" && ((dRace!="" && cRace!=dRace) || (sRace!="" && cRace!=sRace))
		return true
	endIf
	return false
endFunction

; 0=both, 1=humans, 2=creatures
int Function getHumanityFullVal()
	int v0 = getHumanityPart(0)
	int v1 = getHumanityPart(1)
	int v2 = getHumanityPart(2)
	if v0==2 && (v1==2 || v1==-1) && (v2==2 || v2==-1)
		return 2
	elseIf v0==1 && (v1==1 || v1==-1) && (v2==1 || v2==-1)
		return 1
	endIf
	return 0
endFunction

; Returs 0 if both, 1 for humans only, 2 for creatures only
int Function getHumanityPart(int pos)
	int i = getType(pos)
	if i==0 ; Nobody
		return -1
	elseIf i==1 ; Player
		return 1
	elseIf i==2 ; Generic
		i = getHumanity(pos)
		if i==2
			return 2
		else
			return 1
		endIf
	elseIf i==3 ; Generic and Player
		return 1
	elseIf i==4 ; Specific
		; Check if the specifics are creatures
		String part
		if pos==0
			part=dstIDs
		elseIf pos==1
			part=srcIDs
		else
			part=collIDs
		endIf
		String[] parts = StringUtil.split(part, ";")
		bool aHuman = false
		bool aCreature = false
		i = parts.length
		while i
			i-=1
			Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Actor
			if a
				ActorBase ab = a.getActorbase()
				Race r = ab.getRace()
				if sslCreatureAnimationSlots.GetRaceKey(r)!=""
					aCreature=true
				else
					aHuman=true
				endIf
			endIf
		endWhile
		if aHuman && aCreature
			return 0
		elseIf aHuman
			return 1
		else
			return 2
		endIf

	elseIf i==5 ; Relationship
		return 1
	elseIf i==6 ; Relationship
		return 1
	elseIf i==7 ; Faction
		return 1
	elseIf i==8 ; Same Race
		return 2
	endIf
	return -1
endFunction

int Function getPosVal(int pos)
	return getSex(pos) + 4*getFellowship(pos) + 16*getHumanity(pos)
endFunction

int Function getVal(int pos)
	if pos==0
		return dst
	elseIf pos==1
		return src
	endIf
	return coll
endFunction

Function setHighlightColor(int pos, int color, bool isGood)
	{4 bits per position per good/bad (TgtGood,TgtBad,SrcGood,SrcBad,CollGood,CollBad)}
	if pos==0 && isGood
		highLights = Math.LogicalOr(color, Math.LogicalAnd(highLights, 0xFFFFF0))
	elseIf pos==0 && !isGood
		highLights = Math.LogicalOr(color * 0x10, Math.LogicalAnd(highLights, 0xFFFF0F))
	elseIf pos==1 && isGood
		highLights = Math.LogicalOr(color * 0x100, Math.LogicalAnd(highLights, 0xFFF0FF))
	elseIf pos==1 && !isGood
		highLights = Math.LogicalOr(color * 0x1000, Math.LogicalAnd(highLights, 0xFF0FFF))
	elseIf isGood
		highLights = Math.LogicalOr(color * 0x10000, Math.LogicalAnd(highLights, 0xF0FFFF))
	else
		highLights = Math.LogicalOr(color * 0x100000, Math.LogicalAnd(highLights, 0xFFFFF))
	endIf
endFunction


int Function getHighlightColor(int pos, bool isGood)
	if pos==0 && isGood
		return Math.LogicalAnd(highLights, 0xF)
	elseIf pos==0 && !isGood
		return Math.RightShift(Math.LogicalAnd(highLights, 0xF0), 4)
	elseIf pos==1 && isGood
		return Math.RightShift(Math.LogicalAnd(highLights, 0xF00), 8)
	elseIf pos==1 && !isGood
		return Math.RightShift(Math.LogicalAnd(highLights, 0xF000), 12)
	elseIf isGood
		return Math.RightShift(Math.LogicalAnd(highLights, 0xF0000), 16)
	endIf
	return Math.RightShift(Math.LogicalAnd(highLights, 0xF00000), 20)
endFunction


; -))
