Scriptname SSX_Add_To_SSX_Faction_Group_Effect extends ActivemagicEffect

SSX_Runner_Quest Property ssxRunnerQuest Auto
Faction Property ssxGroupFaction Auto
int Property ssxGroupNumber Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	if !akTarget
		debug.notification("[SSX] Your spell fizzles...")
		return
	endIf
	if akTarget.isInFaction(ssxGroupFaction)
		akTarget.removeFromFaction(ssxGroupFaction)
		debug.notification("[SSX] " + akTarget.getDisplayName() + " removed from Group " + ssxGroupNumber)
	else
		akTarget.addToFaction(ssxGroupFaction)
		debug.notification("[SSX] " + akTarget.getDisplayName() + " added to Group " + ssxGroupNumber)
	endIf
	
	int color = ssxRunnerQuest.getFactionGroupColor(ssxGroupNumber)
	if color
		ssxRunnerQuest.hlg(akTarget, color, -1)
	endIf
endEvent
