Scriptname SSX_Catchers_Storage_Alias extends ReferenceAlias ; V1.4

SSX_Rule_Alias rule
Actor act
int[] catchBleeds
int numBleeds
int[] catchNakeds
int numNakeds
int[] catchWeapons
int numWeapons
int[] catchCombats
int numCombats
int[] catchSleeps
int numSleeps
int[] catchHealths
int[] catchHealthLevs
int numHealths
int[] catchClothes
int numClothes


Function doInit(Actor a)
	act=a
	int i
	if !catchBleeds
		catchBleeds = new int[64]
	else
		i=64
		while i
			i-=1
			catchBleeds[i]=0
		endWhile
	endIf
	numBleeds=0
	
	if !catchNakeds
		catchNakeds = new int[64]
	else
		i=64
		while i
			i-=1
			catchNakeds[i]=0
		endWhile
	endIf
	numNakeds=0

	if !catchWeapons
		catchWeapons = new int[64]
	else
		i=64
		while i
			i-=1
			catchWeapons[i]=0
		endWhile
	endIf
	numWeapons=0

	if !catchCombats
		catchCombats = new int[64]
	else
		i=64
		while i
			i-=1
			catchCombats[i]=0
		endWhile
	endIf
	numCombats=0

	if !catchSleeps
		catchSleeps = new int[64]
	else
		i=64
		while i
			i-=1
			catchSleeps[i]=0
		endWhile
	endIf
	numSleeps=0

	if !catchHealths
		catchHealths = new int[64]
	else
		i=64
		while i
			i-=1
			catchHealths[i]=0
		endWhile
	endIf
	numHealths=0

	if !catchHealthLevs
		catchHealthLevs = new int[64]
	else
		i=64
		while i
			i-=1
			catchHealthLevs[i]=0
		endWhile
	endIf

	if !catchClothes
		catchClothes = new int[64]
	else
		i=64
		while i
			i-=1
			catchClothes[i]=0
		endWhile
	endIf
	numClothes=0
endFunction



Function addBleed(int ruleID)
	if catchBleeds.find(ruleID)!=-1
		return
	endIf
	catchBleeds[numBleeds]=ruleID
	numBleeds+=1
endFunction

Function addNaked(int ruleID)
	if catchNakeds.find(ruleID)!=-1
		return
	endIf
	catchNakeds[numNakeds]=ruleID
	numNakeds+=1
endFunction

Function addWeapon(int ruleID)
	if catchWeapons.find(ruleID)!=-1
		return
	endIf
	catchWeapons[numWeapons]=ruleID
	numWeapons+=1
endFunction

Function addCombat(int ruleID)
	if catchCombats.find(ruleID)!=-1
		return
	endIf
	catchCombats[numCombats]=ruleID
	numCombats+=1
endFunction

Function addSleep(int ruleID)
	if catchSleeps.find(ruleID)!=-1
		return
	endIf
	catchSleeps[numSleeps]=ruleID
	numSleeps+=1
endFunction

Function addHealth(int ruleID, int hl)
	if catchHealths.find(ruleID)!=-1
		return
	endIf
	catchHealths[numHealths]=ruleID
	catchHealthLevs[numHealths]=hl
	numHealths+=1
endFunction

Function addClothe(int ruleID)
	if catchClothes.find(ruleID)!=-1
		return
	endIf
	catchClothes[numClothes]=ruleID
	numClothes+=1
endFunction

bool Function requiresCatcher()
	return numBleeds>0 || numNakeds>0 || numWeapons>0 || numCombats>0 || numSleeps>0 || numHealths>0 || numClothes>0
endFunction

bool Function requiresBOorH()
	return numBleeds>0 || numHealths>0
endFunction

int Function getBleedouts(int pos)
	if pos==-1
		return numBleeds
	endIf
	return catchBleeds[pos]
endFunction

int Function getNakeds(int pos)
	if pos==-1
		return numNakeds
	endIf
	return catchNakeds[pos]
endFunction

int Function getSleeps(int pos)
	if pos==-1
		return numSleeps
	endIf
	return catchSleeps[pos]
endFunction

int Function getCombats(int pos)
	if pos==-1
		return numCombats
	endIf
	return catchCombats[pos]
endFunction

int Function getWeapons(int pos)
	if pos==-1
		return numWeapons
	endIf
	return catchWeapons[pos]
endFunction

int Function getClothes(int pos)
	if pos==-1
		return numClothes
	endIf
	return catchClothes[pos]
endFunction

int Function getHealths(int pos)
	if pos==-1
		return numHealths
	endIf
	return catchHealths[pos]
endFunction

int Function getHealthLevs(int pos)
	if pos==-1
		return numHealths
	endIf
	return catchHealthLevs[pos]
endFunction

Function setActor(Actor a)
	if act==a
		return
	endIf
	doInit(a)
endFunction
