Scriptname SSX_Deferred_Tags_Loader_Quest extends Quest ; V1.4a

SSX_Runner_Quest Property ssxRunnerQuest Auto
bool areAlreadyRescanning
String[] tmpTags
int numT

Function doInit()
	UnregisterForAllModEvents()
	areAlreadyRescanning = false
	RegisterForModEvent("ssxRescanTags", "DoRescan")
	if !tmpTags
		tmpTags = SSX_Runner_Quest.CreateStringArray(256)
		numT = 0
	endIf
	ssxRunnerQuest.log("Deferred Tags Loader started", SSX_Runner_Quest.notifDeferredDetails())
EndFunction

Event DoRescan(string fromWho)
	if areAlreadyRescanning
		return
	endIf
	areAlreadyRescanning = true
	ssxRunnerQuest.startT("Tags scanning " + fromWho)
	ssxRunnerQuest.log("scanning of animation tags started", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.areTagsInProgress=0
	if !tmpTags
		; Try to re-create, then fail
		tmpTags = SSX_Runner_Quest.CreateStringArray(256)
		Utility.waitMenuMode(0.1)
		if !tmpTags
			tmpTags = SSX_Runner_Quest.CreateStringArray(256)
			Utility.waitMenuMode(0.1)
			if !tmpTags
				debug.messagebox(ssxRunnerQuest.s("$SSX_WarningCannotInitLongArrayForTags"))
				tmpTags = new String[8]
				tmpTags[0] = "Sex"
				tmpTags[1] = "Oral"
				tmpTags[2] = "Vaginal"
				tmpTags[3] = "Anal"
				tmpTags[4] = "Blowjob"
				tmpTags[5] = "Footjob"
				tmpTags[6] = "Boobjob"
				tmpTags[7] = "Orgy"
				ssxRunnerQuest.allTags = tmpTags
				ssxRunnerQuest.numTags = 8
				areAlreadyRescanning = false
				ssxRunnerQuest.areTagsInProgress=100
				return
			endIf
		endIf
	endIf
	numT = tmpTags.length
	while numT
		numT -= 1
		tmpTags[numT] = ""
	endWhile
	ssxRunnerQuest.areTagsInProgress=1
	numT = 0
	; Get all possible tags from human animations (aggressive and non aggressive)
	int numActors = 1
	while numActors < 6
		sslBaseAnimation[] anims = ssxRunnerQuest.SexLab.GetAnimationsByType(numActors) ; Non aggressive
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		int slAnimNum = anims.length
		while slAnimNum && numT<256
			slAnimNum -= 1
			sslBaseAnimation a = anims[slAnimNum]
			if a
				String[] animTags = a.GetTags()
				int t = animTags.length
				while t && numT<256
					t -= 1
					if tmpTags.find(animTags[t]) == -1 ; Add this tags
						tmpTags[numT] = animTags[t]
						numT += 1
					endIf
				endWhile
			endIf
			; Publish the available step, unsorted
			ssxRunnerQuest.allTags = tmpTags
			ssxRunnerQuest.numTags = numT
		endWhile
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		anims = ssxRunnerQuest.SexLab.GetAnimationsByType(numActors, Aggressive=True) ; Aggressive
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		slAnimNum = anims.length
		while slAnimNum && numT<256
			slAnimNum -= 1
			sslBaseAnimation a = anims[slAnimNum]
			if a
				String[] animTags = a.GetTags()
				int t = animTags.length
				while t
					t -= 1
					if tmpTags.find(animTags[t]) == -1 ; Add this tags
						tmpTags[numT] = animTags[t]
						numT += 1
					endIf
				endWhile
			endIf
			; Publish the available step
			ssxRunnerQuest.allTags = tmpTags
			ssxRunnerQuest.numTags = numT
		endWhile
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		numActors += 1
	endWhile

	; Get all possible tags from creature animations, because the list of races is completed only when the loader has completed, then we need to wait here for its completion
	while ssxRunnerQuest.isConfigInProgress<100
		Utility.waitMenuMode(0.2)
	endWhile
	
	String[] allRacesC = sslCreatureAnimationSlots.GetAllRaceKeys()
	int r = allRacesC.length
	while r
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		r -= 1
		sslBaseAnimation[] anims = ssxRunnerQuest.SexLab.GetCreatureAnimationsByRaceKey(2, allRacesC[r])
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		int slAnimNum = anims.length
		while slAnimNum && numT<256
			slAnimNum -= 1
			sslBaseAnimation a = anims[slAnimNum]
			if a
				String[] animTags = a.GetTags()
				int t = animTags.length
				while t
					t -= 1
					if tmpTags.find(animTags[t]) == -1 ; Add this tags
						tmpTags[numT] = animTags[t]
						numT += 1
					endIf
				endWhile
			endIf
		endWhile
		; Publish the available step
		ssxRunnerQuest.allTags = tmpTags
		ssxRunnerQuest.numTags = numT
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		anims = ssxRunnerQuest.SexLab.GetCreatureAnimationsByRaceKey(3, allRacesC[r])
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
		slAnimNum = anims.length
		while slAnimNum && numT<256
			slAnimNum -= 1
			sslBaseAnimation a = anims[slAnimNum]
			if a
				String[] animTags = a.GetTags()
				int t = animTags.length
				while t
					t -= 1
					if tmpTags.find(animTags[t]) == -1 ; Add this tags
						tmpTags[numT] = animTags[t]
						numT += 1
					endIf
				endWhile
			endIf
		endWhile
		; Publish the available step
		ssxRunnerQuest.allTags = tmpTags
		ssxRunnerQuest.numTags = numT
		ssxRunnerQuest.areTagsInProgress = ssxRunnerQuest.areTagsInProgress + 1
	endWhile

	; Fix for PapyrusUtil.SortStringArray, in case some strings are empty, the result is an empty array
	int i=numT
	while i<tmpTags.length
		tmpTags[i]="ÿÿÿÿÿÿ"
		i+=1
	endWhile
	PapyrusUtil.SortStringArray(tmpTags)
	i=numT
	while i<tmpTags.length
		tmpTags[i]=""
		i+=1
	endWhile
	
	ssxRunnerQuest.areTagsInProgress = 99
	ssxRunnerQuest.allTags = tmpTags
	ssxRunnerQuest.numTags = numT
	areAlreadyRescanning = false
	ssxRunnerQuest.areTagsInProgress = 100
	ssxRunnerQuest.log("Scanning of animation tags completed", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.endT("Tags scanning " + fromWho)
EndEvent

