Scriptname SSX_Player_Cell_Detector_Effect extends activemagiceffect  
{ability that will be activated when player is not in the same cell as ssxPlayerCellDetector}
 
Actor property PlayerRef auto
ObjectReference Property ssxPlayerCellDetector auto
SSX_Runner_Quest Property ssxRunnerQuest Auto
Cell previousCell

Event OnEffectStart(Actor akTarget, Actor akCaster)
	if !PlayerRef
		return
	endIf
	Cell currentCell = PlayerRef.getParentCell()
	ssxPlayerCellDetector.MoveTo(PlayerRef)
	if currentCell==previousCell
		return
	endIf
	bool cInterior = false
	bool pInterior = false
	if currentCell
		cInterior = currentCell.IsInterior()
		if previousCell
			pInterior = previousCell.IsInterior()
		endIf
		if cInterior || pInterior
			int handle = ModEvent.Create("ssxStopScenes")
			ModEvent.PushString(handle, "doIt")
			ModEvent.Send(handle)
			handle = ModEvent.Create("ssxScanCell")
			ModEvent.PushString(handle, "CellScanner")
			ModEvent.Send(handle)
		endIf
		ssxRunnerQuest.updateCellAndLocation(currentCell)
	endIf
	previousCell = currentCell
	Utility.waitMenuMode(0.5)
EndEvent
